/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 1 "chuck.y"


/*----------------------------------------------------------------------------
  ChucK Strongly-timed Audio Programming Language
    Compiler and Virtual Machine

  Copyright (c) 2003 Ge Wang and Perry R. Cook. All rights reserved.
    http://chuck.cs.princeton.edu/
    http://soundlab.cs.princeton.edu/

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
  U.S.A.
-----------------------------------------------------------------------------*/

//-----------------------------------------------------------------------------
// file: chuck.tab.c
// desc: chuck parser
//
// author: Ge Wang (gewang@cs.princeton.edu) - generated by yacc
//         Perry R. Cook (prc@cs.princeton.edu)
//
// initial version created by Ge Wang;
// based on ansi C grammar by Jeff Lee, maintained by Jutta Degener
//
// date: Summer 2002
//-----------------------------------------------------------------------------
#include "chuck_absyn.h"
#include "chuck_errmsg.h"

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

// function
int yylex( void );

void yyerror( char * s )
{
    EM_error( EM_tokPos, "%s", s );
}

a_Program g_program = NULL;


#line 128 "chuck.tab.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "chuck.tab.h"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_ID = 3,                         /* ID  */
  YYSYMBOL_STRING_LIT = 4,                 /* STRING_LIT  */
  YYSYMBOL_CHAR_LIT = 5,                   /* CHAR_LIT  */
  YYSYMBOL_INT_VAL = 6,                    /* INT_VAL  */
  YYSYMBOL_FLOAT_VAL = 7,                  /* FLOAT_VAL  */
  YYSYMBOL_POUND = 8,                      /* POUND  */
  YYSYMBOL_COMMA = 9,                      /* COMMA  */
  YYSYMBOL_COLON = 10,                     /* COLON  */
  YYSYMBOL_SEMICOLON = 11,                 /* SEMICOLON  */
  YYSYMBOL_LPAREN = 12,                    /* LPAREN  */
  YYSYMBOL_RPAREN = 13,                    /* RPAREN  */
  YYSYMBOL_LBRACK = 14,                    /* LBRACK  */
  YYSYMBOL_RBRACK = 15,                    /* RBRACK  */
  YYSYMBOL_LBRACE = 16,                    /* LBRACE  */
  YYSYMBOL_RBRACE = 17,                    /* RBRACE  */
  YYSYMBOL_DOT = 18,                       /* DOT  */
  YYSYMBOL_PLUS = 19,                      /* PLUS  */
  YYSYMBOL_MINUS = 20,                     /* MINUS  */
  YYSYMBOL_TIMES = 21,                     /* TIMES  */
  YYSYMBOL_DIVIDE = 22,                    /* DIVIDE  */
  YYSYMBOL_PERCENT = 23,                   /* PERCENT  */
  YYSYMBOL_EQ = 24,                        /* EQ  */
  YYSYMBOL_NEQ = 25,                       /* NEQ  */
  YYSYMBOL_LT = 26,                        /* LT  */
  YYSYMBOL_LE = 27,                        /* LE  */
  YYSYMBOL_GT = 28,                        /* GT  */
  YYSYMBOL_GE = 29,                        /* GE  */
  YYSYMBOL_AND = 30,                       /* AND  */
  YYSYMBOL_OR = 31,                        /* OR  */
  YYSYMBOL_ASSIGN = 32,                    /* ASSIGN  */
  YYSYMBOL_IF = 33,                        /* IF  */
  YYSYMBOL_THEN = 34,                      /* THEN  */
  YYSYMBOL_ELSE = 35,                      /* ELSE  */
  YYSYMBOL_WHILE = 36,                     /* WHILE  */
  YYSYMBOL_FOR = 37,                       /* FOR  */
  YYSYMBOL_DO = 38,                        /* DO  */
  YYSYMBOL_LOOP = 39,                      /* LOOP  */
  YYSYMBOL_BREAK = 40,                     /* BREAK  */
  YYSYMBOL_CONTINUE = 41,                  /* CONTINUE  */
  YYSYMBOL_NULL_TOK = 42,                  /* NULL_TOK  */
  YYSYMBOL_FUNCTION = 43,                  /* FUNCTION  */
  YYSYMBOL_RETURN = 44,                    /* RETURN  */
  YYSYMBOL_QUESTION = 45,                  /* QUESTION  */
  YYSYMBOL_EXCLAMATION = 46,               /* EXCLAMATION  */
  YYSYMBOL_S_OR = 47,                      /* S_OR  */
  YYSYMBOL_S_AND = 48,                     /* S_AND  */
  YYSYMBOL_S_XOR = 49,                     /* S_XOR  */
  YYSYMBOL_PLUSPLUS = 50,                  /* PLUSPLUS  */
  YYSYMBOL_MINUSMINUS = 51,                /* MINUSMINUS  */
  YYSYMBOL_DOLLAR = 52,                    /* DOLLAR  */
  YYSYMBOL_POUNDPAREN = 53,                /* POUNDPAREN  */
  YYSYMBOL_PERCENTPAREN = 54,              /* PERCENTPAREN  */
  YYSYMBOL_ATPAREN = 55,                   /* ATPAREN  */
  YYSYMBOL_SIMULT = 56,                    /* SIMULT  */
  YYSYMBOL_PATTERN = 57,                   /* PATTERN  */
  YYSYMBOL_CODE = 58,                      /* CODE  */
  YYSYMBOL_TRANSPORT = 59,                 /* TRANSPORT  */
  YYSYMBOL_HOST = 60,                      /* HOST  */
  YYSYMBOL_TIME = 61,                      /* TIME  */
  YYSYMBOL_WHENEVER = 62,                  /* WHENEVER  */
  YYSYMBOL_NEXT = 63,                      /* NEXT  */
  YYSYMBOL_UNTIL = 64,                     /* UNTIL  */
  YYSYMBOL_EXTERNAL = 65,                  /* EXTERNAL  */
  YYSYMBOL_GLOBAL = 66,                    /* GLOBAL  */
  YYSYMBOL_EVERY = 67,                     /* EVERY  */
  YYSYMBOL_BEFORE = 68,                    /* BEFORE  */
  YYSYMBOL_AFTER = 69,                     /* AFTER  */
  YYSYMBOL_AT = 70,                        /* AT  */
  YYSYMBOL_AT_SYM = 71,                    /* AT_SYM  */
  YYSYMBOL_ATAT_SYM = 72,                  /* ATAT_SYM  */
  YYSYMBOL_NEW = 73,                       /* NEW  */
  YYSYMBOL_SIZEOF = 74,                    /* SIZEOF  */
  YYSYMBOL_TYPEOF = 75,                    /* TYPEOF  */
  YYSYMBOL_SAME = 76,                      /* SAME  */
  YYSYMBOL_PLUS_CHUCK = 77,                /* PLUS_CHUCK  */
  YYSYMBOL_MINUS_CHUCK = 78,               /* MINUS_CHUCK  */
  YYSYMBOL_TIMES_CHUCK = 79,               /* TIMES_CHUCK  */
  YYSYMBOL_DIVIDE_CHUCK = 80,              /* DIVIDE_CHUCK  */
  YYSYMBOL_S_AND_CHUCK = 81,               /* S_AND_CHUCK  */
  YYSYMBOL_S_OR_CHUCK = 82,                /* S_OR_CHUCK  */
  YYSYMBOL_S_XOR_CHUCK = 83,               /* S_XOR_CHUCK  */
  YYSYMBOL_SHIFT_RIGHT_CHUCK = 84,         /* SHIFT_RIGHT_CHUCK  */
  YYSYMBOL_SHIFT_LEFT_CHUCK = 85,          /* SHIFT_LEFT_CHUCK  */
  YYSYMBOL_PERCENT_CHUCK = 86,             /* PERCENT_CHUCK  */
  YYSYMBOL_SHIFT_RIGHT = 87,               /* SHIFT_RIGHT  */
  YYSYMBOL_SHIFT_LEFT = 88,                /* SHIFT_LEFT  */
  YYSYMBOL_TILDA = 89,                     /* TILDA  */
  YYSYMBOL_CHUCK = 90,                     /* CHUCK  */
  YYSYMBOL_COLONCOLON = 91,                /* COLONCOLON  */
  YYSYMBOL_S_CHUCK = 92,                   /* S_CHUCK  */
  YYSYMBOL_AT_CHUCK = 93,                  /* AT_CHUCK  */
  YYSYMBOL_LEFT_S_CHUCK = 94,              /* LEFT_S_CHUCK  */
  YYSYMBOL_UNCHUCK = 95,                   /* UNCHUCK  */
  YYSYMBOL_UPCHUCK = 96,                   /* UPCHUCK  */
  YYSYMBOL_CLASS = 97,                     /* CLASS  */
  YYSYMBOL_INTERFACE = 98,                 /* INTERFACE  */
  YYSYMBOL_EXTENDS = 99,                   /* EXTENDS  */
  YYSYMBOL_IMPLEMENTS = 100,               /* IMPLEMENTS  */
  YYSYMBOL_PUBLIC = 101,                   /* PUBLIC  */
  YYSYMBOL_PROTECTED = 102,                /* PROTECTED  */
  YYSYMBOL_PRIVATE = 103,                  /* PRIVATE  */
  YYSYMBOL_STATIC = 104,                   /* STATIC  */
  YYSYMBOL_ABSTRACT = 105,                 /* ABSTRACT  */
  YYSYMBOL_CONST = 106,                    /* CONST  */
  YYSYMBOL_SPORK = 107,                    /* SPORK  */
  YYSYMBOL_ARROW_RIGHT = 108,              /* ARROW_RIGHT  */
  YYSYMBOL_ARROW_LEFT = 109,               /* ARROW_LEFT  */
  YYSYMBOL_L_HACK = 110,                   /* L_HACK  */
  YYSYMBOL_R_HACK = 111,                   /* R_HACK  */
  YYSYMBOL_GRUCK_RIGHT = 112,              /* GRUCK_RIGHT  */
  YYSYMBOL_GRUCK_LEFT = 113,               /* GRUCK_LEFT  */
  YYSYMBOL_UNGRUCK_RIGHT = 114,            /* UNGRUCK_RIGHT  */
  YYSYMBOL_UNGRUCK_LEFT = 115,             /* UNGRUCK_LEFT  */
  YYSYMBOL_AT_OP = 116,                    /* AT_OP  */
  YYSYMBOL_AT_CTOR = 117,                  /* AT_CTOR  */
  YYSYMBOL_AT_DTOR = 118,                  /* AT_DTOR  */
  YYSYMBOL_YYACCEPT = 119,                 /* $accept  */
  YYSYMBOL_program = 120,                  /* program  */
  YYSYMBOL_program_section = 121,          /* program_section  */
  YYSYMBOL_class_definition = 122,         /* class_definition  */
  YYSYMBOL_class_ext = 123,                /* class_ext  */
  YYSYMBOL_class_body = 124,               /* class_body  */
  YYSYMBOL_class_body2 = 125,              /* class_body2  */
  YYSYMBOL_class_section = 126,            /* class_section  */
  YYSYMBOL_iface_ext = 127,                /* iface_ext  */
  YYSYMBOL_id_list = 128,                  /* id_list  */
  YYSYMBOL_id_dot = 129,                   /* id_dot  */
  YYSYMBOL_function_definition = 130,      /* function_definition  */
  YYSYMBOL_class_decl = 131,               /* class_decl  */
  YYSYMBOL_function_decl = 132,            /* function_decl  */
  YYSYMBOL_static_decl = 133,              /* static_decl  */
  YYSYMBOL_type_decl_a = 134,              /* type_decl_a  */
  YYSYMBOL_type_decl_b = 135,              /* type_decl_b  */
  YYSYMBOL_type_decl = 136,                /* type_decl  */
  YYSYMBOL_type_decl2 = 137,               /* type_decl2  */
  YYSYMBOL_arg_list = 138,                 /* arg_list  */
  YYSYMBOL_statement_list = 139,           /* statement_list  */
  YYSYMBOL_statement = 140,                /* statement  */
  YYSYMBOL_jump_statement = 141,           /* jump_statement  */
  YYSYMBOL_selection_statement = 142,      /* selection_statement  */
  YYSYMBOL_loop_statement = 143,           /* loop_statement  */
  YYSYMBOL_code_segment = 144,             /* code_segment  */
  YYSYMBOL_expression_statement = 145,     /* expression_statement  */
  YYSYMBOL_expression = 146,               /* expression  */
  YYSYMBOL_chuck_expression = 147,         /* chuck_expression  */
  YYSYMBOL_arrow_expression = 148,         /* arrow_expression  */
  YYSYMBOL_array_exp = 149,                /* array_exp  */
  YYSYMBOL_array_empty = 150,              /* array_empty  */
  YYSYMBOL_decl_expression = 151,          /* decl_expression  */
  YYSYMBOL_var_decl_list = 152,            /* var_decl_list  */
  YYSYMBOL_var_decl = 153,                 /* var_decl  */
  YYSYMBOL_complex_exp = 154,              /* complex_exp  */
  YYSYMBOL_polar_exp = 155,                /* polar_exp  */
  YYSYMBOL_vec_exp = 156,                  /* vec_exp  */
  YYSYMBOL_chuck_operator = 157,           /* chuck_operator  */
  YYSYMBOL_arrow_operator = 158,           /* arrow_operator  */
  YYSYMBOL_conditional_expression = 159,   /* conditional_expression  */
  YYSYMBOL_logical_or_expression = 160,    /* logical_or_expression  */
  YYSYMBOL_logical_and_expression = 161,   /* logical_and_expression  */
  YYSYMBOL_inclusive_or_expression = 162,  /* inclusive_or_expression  */
  YYSYMBOL_exclusive_or_expression = 163,  /* exclusive_or_expression  */
  YYSYMBOL_and_expression = 164,           /* and_expression  */
  YYSYMBOL_equality_expression = 165,      /* equality_expression  */
  YYSYMBOL_relational_expression = 166,    /* relational_expression  */
  YYSYMBOL_shift_expression = 167,         /* shift_expression  */
  YYSYMBOL_additive_expression = 168,      /* additive_expression  */
  YYSYMBOL_multiplicative_expression = 169, /* multiplicative_expression  */
  YYSYMBOL_tilda_expression = 170,         /* tilda_expression  */
  YYSYMBOL_cast_expression = 171,          /* cast_expression  */
  YYSYMBOL_unary_expression = 172,         /* unary_expression  */
  YYSYMBOL_unary_operator = 173,           /* unary_operator  */
  YYSYMBOL_overloadable_operator = 174,    /* overloadable_operator  */
  YYSYMBOL_dur_expression = 175,           /* dur_expression  */
  YYSYMBOL_postfix_expression = 176,       /* postfix_expression  */
  YYSYMBOL_primary_expression = 177        /* primary_expression  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
             && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE) \
             + YYSIZEOF (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  122
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   1993

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  119
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  59
/* YYNRULES -- Number of rules.  */
#define YYNRULES  255
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  432

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   373


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   206,   206,   207,   211,   212,   213,   217,   219,   221,
     223,   228,   229,   230,   231,   235,   236,   240,   241,   246,
     247,   248,   252,   256,   257,   261,   262,   266,   268,   270,
     272,   274,   276,   278,   280,   282,   284,   286,   288,   290,
     292,   297,   298,   299,   303,   304,   305,   306,   310,   311,
     312,   316,   317,   321,   322,   331,   332,   337,   338,   342,
     343,   347,   348,   352,   353,   354,   355,   357,   361,   362,
     363,   364,   368,   370,   375,   377,   379,   381,   383,   385,
     387,   389,   394,   395,   399,   400,   404,   405,   409,   410,
     415,   416,   421,   422,   423,   425,   430,   431,   435,   436,
     437,   438,   439,   440,   441,   445,   446,   450,   451,   452,
     453,   454,   455,   456,   460,   465,   470,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   492,   493,   494,   495,   496,   497,   501,   502,   507,
     508,   513,   514,   519,   520,   525,   526,   531,   532,   537,
     538,   540,   545,   546,   548,   550,   552,   557,   558,   560,
     565,   566,   568,   573,   574,   576,   578,   583,   584,   589,
     590,   595,   596,   598,   600,   602,   604,   606,   608,   610,
     612,   614,   616,   623,   624,   625,   626,   627,   628,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,   673,   674,
     675,   676,   677,   678,   679,   683,   684,   689,   690,   692,
     694,   696,   698,   700,   706,   707,   708,   709,   710,   711,
     712,   713,   714,   715,   716,   717
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "ID", "STRING_LIT",
  "CHAR_LIT", "INT_VAL", "FLOAT_VAL", "POUND", "COMMA", "COLON",
  "SEMICOLON", "LPAREN", "RPAREN", "LBRACK", "RBRACK", "LBRACE", "RBRACE",
  "DOT", "PLUS", "MINUS", "TIMES", "DIVIDE", "PERCENT", "EQ", "NEQ", "LT",
  "LE", "GT", "GE", "AND", "OR", "ASSIGN", "IF", "THEN", "ELSE", "WHILE",
  "FOR", "DO", "LOOP", "BREAK", "CONTINUE", "NULL_TOK", "FUNCTION",
  "RETURN", "QUESTION", "EXCLAMATION", "S_OR", "S_AND", "S_XOR",
  "PLUSPLUS", "MINUSMINUS", "DOLLAR", "POUNDPAREN", "PERCENTPAREN",
  "ATPAREN", "SIMULT", "PATTERN", "CODE", "TRANSPORT", "HOST", "TIME",
  "WHENEVER", "NEXT", "UNTIL", "EXTERNAL", "GLOBAL", "EVERY", "BEFORE",
  "AFTER", "AT", "AT_SYM", "ATAT_SYM", "NEW", "SIZEOF", "TYPEOF", "SAME",
  "PLUS_CHUCK", "MINUS_CHUCK", "TIMES_CHUCK", "DIVIDE_CHUCK",
  "S_AND_CHUCK", "S_OR_CHUCK", "S_XOR_CHUCK", "SHIFT_RIGHT_CHUCK",
  "SHIFT_LEFT_CHUCK", "PERCENT_CHUCK", "SHIFT_RIGHT", "SHIFT_LEFT",
  "TILDA", "CHUCK", "COLONCOLON", "S_CHUCK", "AT_CHUCK", "LEFT_S_CHUCK",
  "UNCHUCK", "UPCHUCK", "CLASS", "INTERFACE", "EXTENDS", "IMPLEMENTS",
  "PUBLIC", "PROTECTED", "PRIVATE", "STATIC", "ABSTRACT", "CONST", "SPORK",
  "ARROW_RIGHT", "ARROW_LEFT", "L_HACK", "R_HACK", "GRUCK_RIGHT",
  "GRUCK_LEFT", "UNGRUCK_RIGHT", "UNGRUCK_LEFT", "AT_OP", "AT_CTOR",
  "AT_DTOR", "$accept", "program", "program_section", "class_definition",
  "class_ext", "class_body", "class_body2", "class_section", "iface_ext",
  "id_list", "id_dot", "function_definition", "class_decl",
  "function_decl", "static_decl", "type_decl_a", "type_decl_b",
  "type_decl", "type_decl2", "arg_list", "statement_list", "statement",
  "jump_statement", "selection_statement", "loop_statement",
  "code_segment", "expression_statement", "expression", "chuck_expression",
  "arrow_expression", "array_exp", "array_empty", "decl_expression",
  "var_decl_list", "var_decl", "complex_exp", "polar_exp", "vec_exp",
  "chuck_operator", "arrow_operator", "conditional_expression",
  "logical_or_expression", "logical_and_expression",
  "inclusive_or_expression", "exclusive_or_expression", "and_expression",
  "equality_expression", "relational_expression", "shift_expression",
  "additive_expression", "multiplicative_expression", "tilda_expression",
  "cast_expression", "unary_expression", "unary_operator",
  "overloadable_operator", "dur_expression", "postfix_expression",
  "primary_expression", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-306)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-52)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     648,    14,  -306,  -306,  -306,  -306,  -306,   944,  1547,   727,
    -306,  -306,  -306,    39,    25,   102,   118,   879,   133,    59,
     125,  -306,  1018,  -306,  1612,  1612,  1547,  1547,  1547,   142,
      28,    28,    28,  1612,  1612,   181,  -306,   -68,  -306,   -49,
      20,    68,  1547,   411,  -306,  -306,  -306,   -10,    57,  -306,
    -306,   181,   879,  -306,  -306,  -306,  -306,  -306,  -306,   190,
     130,    26,  -306,  -306,  -306,  -306,  -306,  -306,    58,   141,
     113,   180,   198,   238,   207,   179,   249,    76,   101,   197,
    -306,  1612,   163,    33,  -306,  -306,  -306,   119,    24,  -306,
     803,   242,   237,  1547,  1547,  1092,    -1,  1547,  -306,  -306,
    -306,   210,  -306,  -306,  -306,   154,   156,   157,  1547,   205,
     181,   181,    55,  -306,  -306,   247,  -306,   271,   181,   181,
    -306,     7,  -306,  -306,   278,   278,  -306,  -306,   270,   272,
      79,  -306,  -306,  1547,  -306,  -306,  -306,  -306,  -306,  -306,
    -306,  -306,  -306,  -306,  -306,  -306,  -306,  -306,  -306,  1547,
    -306,  -306,  -306,  -306,  -306,  -306,  1547,  1612,  1547,  1612,
    1612,  1612,  1612,  1612,  1612,  1612,  1612,  1612,  1612,  1612,
    1612,  1612,  1612,  1612,  1612,  1612,  1612,    28,  -306,    54,
    1157,   280,  -306,  -306,  -306,  -306,  1222,   273,  -306,    39,
     214,   159,   168,  1092,   234,   274,   276,   170,  -306,  -306,
    -306,  -306,   173,  -306,  -306,  1287,  -306,  1352,  1417,  -306,
     275,   181,  -306,  -306,  -306,   281,     2,    12,    91,   116,
      15,   277,     6,   130,    26,  -306,   141,   261,   113,   180,
     198,   238,   207,   207,   179,   179,   179,   179,   249,   249,
      76,    76,   101,   101,   101,   197,  -306,    33,  -306,   178,
    -306,   273,  -306,  -306,  -306,   879,   879,  1482,  1547,  1547,
    1547,   879,   879,   273,   184,   273,   187,  -306,   279,  -306,
     278,   490,    39,   278,   283,   490,   278,   284,   285,   181,
     289,   285,   290,   120,   291,   275,   292,  1683,  1612,  -306,
    -306,   257,  -306,   879,   189,   209,   215,   218,  -306,  -306,
    -306,   273,  -306,   273,  -306,  -306,  -306,   288,  -306,   569,
    -306,   879,   193,   208,   490,   293,  -306,   490,  -306,   299,
     285,  -306,   285,   285,   296,   124,   295,  -306,  -306,  -306,
    -306,  -306,  -306,  -306,  -306,  -306,  -306,  -306,  -306,  -306,
    -306,  -306,  -306,  -306,  -306,  -306,  -306,  -306,  -306,  -306,
    -306,  -306,  -306,  -306,  -306,  -306,  -306,  -306,  -306,  -306,
    -306,  -306,  -306,  -306,  -306,  -306,  -306,  -306,  -306,  -306,
    -306,  -306,  -306,   300,  -306,   879,  -306,   879,   879,   302,
     317,  -306,  -306,  -306,  -306,   278,    39,   294,  -306,   312,
      28,  -306,  -306,  -306,   285,   115,   318,    39,   319,   320,
      28,  -306,  -306,  -306,  -306,  -306,  -306,  -306,  -306,  -306,
    -306,  -306,  -306,  -306,   132,  1781,   322,   323,  -306,  -306,
    1878,   285,    28,   285,   324,  -306,   325,  -306,   285,   285,
    -306,  -306
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
      43,   244,   247,   248,   245,   246,    84,     0,     0,     0,
     183,   184,   187,     0,     0,     0,     0,     0,     0,     0,
       0,    44,     0,   186,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   185,    45,    46,    47,
       0,     0,     0,    43,     2,     6,     5,     0,    50,    55,
      56,     0,     4,    61,    66,    65,    64,    67,    63,     0,
      86,    88,   249,    90,   250,   251,   252,    98,   137,   139,
     141,   143,   145,   147,   149,   152,   157,   160,   163,   167,
     169,     0,   171,   235,   237,    52,   255,     0,     0,    82,
       0,    25,     0,     0,     0,     0,     0,     0,    70,    71,
      68,     0,   244,   172,   173,     0,     0,     0,     0,    51,
       0,     0,   177,   176,   175,   107,   103,   105,     0,     0,
     188,     0,     1,     3,     0,     0,    48,    49,     0,     0,
       0,    99,    62,     0,    85,   119,   120,   121,   122,   128,
     129,   130,   123,   124,   125,   117,   118,   126,   127,     0,
     132,   131,   134,   133,   136,   135,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   174,     0,
       0,     0,   242,   243,   238,   254,     0,    92,    83,     0,
      53,     0,     0,     0,     0,     0,     0,     0,    69,   114,
     115,   116,     0,   100,   101,     0,   178,     0,     0,   108,
     109,     0,   104,   102,   253,    23,     0,     0,     0,     0,
      51,    57,     0,    87,    89,    91,   140,     0,   142,   144,
     146,   148,   150,   151,   153,   155,   154,   156,   159,   158,
     161,   162,   164,   165,   166,   168,   170,   236,   239,     0,
     241,    93,    94,    26,    54,     0,     0,     0,     0,     0,
       0,     0,     0,   179,     0,   110,     0,    96,     0,   106,
       0,    43,     0,     0,     0,    43,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    58,     0,     0,     0,   240,
      95,    72,    74,     0,     0,     0,     0,     0,    81,    79,
     181,   180,   112,   111,    97,    24,    21,     0,    15,    43,
      20,    19,    13,    11,    43,     0,    22,    43,    32,    59,
       0,    33,     0,     0,     0,     0,     0,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   189,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,     0,   138,     0,    76,     0,     0,     0,
       0,   182,   113,     7,    18,     0,     0,     0,     9,     0,
       0,    31,    34,    30,     0,     0,     0,   197,     0,     0,
       0,    73,    77,    78,    75,    80,    14,    12,     8,    10,
      60,    29,    36,    28,     0,     0,     0,     0,    35,    27,
       0,     0,     0,     0,     0,    38,     0,    37,     0,     0,
      40,    39
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -306,  -306,   287,    19,  -306,  -243,    30,  -306,  -306,  -121,
    -182,    36,  -306,  -306,  -306,  -306,  -306,   -30,  -306,  -205,
      34,   -14,  -306,  -306,  -306,  -270,   -80,    -2,  -111,   186,
     -71,   127,   194,   -38,    61,  -306,  -306,  -306,  -306,  -306,
      63,  -306,   192,   195,   196,   191,   200,   109,    72,   105,
     106,    77,   177,    31,  -306,  -305,  -306,   176,  -306
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
       0,    43,    44,   306,   274,   307,   308,   309,   277,   216,
      92,   310,    47,    48,   130,    49,    50,    51,   222,   280,
     311,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,   210,    63,   116,   117,    64,    65,    66,   149,   156,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,   373,    82,    83,    84
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     110,   111,   112,    96,   217,    87,    88,   253,   318,   286,
     119,   321,   184,   131,   282,   193,   133,   -51,   271,    45,
     101,   399,   223,   109,   105,   106,   107,   283,   275,   -41,
     -41,   109,   315,   186,    52,   195,    46,    93,   132,   187,
     121,   206,    91,    90,   209,   180,    13,     8,   -42,   -42,
     391,   181,   392,   393,    13,   103,   104,   102,     2,     3,
       4,     5,    45,   196,   113,   114,     7,   205,     8,     8,
      98,   387,   203,   204,   389,   223,   132,    52,   324,    46,
     212,   213,   220,   182,   183,    85,    85,   124,   125,   157,
     312,   191,   192,   194,   109,   197,   118,   173,   174,   175,
     221,   272,   273,   158,   278,    13,   202,    26,    27,    28,
     421,   276,   178,   257,    94,   424,   252,    13,   214,   109,
     396,   398,   287,   109,   411,   413,   412,   109,   133,   281,
      95,     9,   185,   323,   150,   151,    99,   395,   152,   153,
     154,   155,    13,   418,   419,    97,    13,   246,     9,   305,
      13,   425,   313,   427,   108,   316,   227,   120,   430,   431,
     160,   126,   127,   133,    42,   133,   133,   199,   133,   200,
     201,   159,   255,   269,   128,   129,   184,   133,   249,   133,
     290,   256,   133,   261,   115,   410,   262,   133,   279,   279,
     176,   289,   300,   133,   302,   417,   133,   301,   133,   133,
     303,   134,   377,   264,   407,   266,    88,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   426,   133,   133,
     145,   198,   378,   146,   133,   147,   148,   133,   379,   161,
     381,   380,   382,   165,   166,   167,   168,   234,   235,   236,
     237,   291,   292,   133,   258,   134,   162,   298,   299,   177,
     242,   243,   244,   279,   179,   294,   295,   296,   297,   207,
     189,   208,   163,   164,   406,   190,   169,   170,   171,   172,
     133,   288,   232,   233,   238,   239,    85,   240,   241,   376,
     211,   215,   218,   250,   219,   254,   259,     8,   260,   268,
     270,   284,   375,   385,   304,   279,   279,   132,   109,   314,
     317,     9,   320,   322,   325,   383,   267,   386,   390,   394,
     388,   408,   400,   404,   327,   328,   329,   330,   331,   332,
     333,   397,   335,   336,   337,   338,   339,   340,   405,   409,
     123,   414,   415,   416,   422,   224,   423,   428,   429,   384,
     319,   341,   342,   343,   344,   345,   346,   347,   285,   226,
     225,   374,   230,   245,   228,   247,   229,     0,     0,     0,
     279,   401,   231,   402,   403,     0,     0,   348,     0,     0,
     279,     0,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,     0,   364,     0,
     365,   366,   279,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   367,   368,     0,     0,   369,   370,   371,
     372,   122,     0,     0,     1,     2,     3,     4,     5,     0,
       0,     0,     6,     7,     0,     8,     0,     9,     0,     0,
      10,    11,    12,     0,     0,     0,     0,    13,     0,     0,
       0,     0,     0,     0,    14,     0,     0,    15,    16,    17,
      18,    19,    20,     0,    21,    22,     0,    23,     0,     0,
       0,    24,    25,     0,    26,    27,    28,     0,     0,     0,
       0,     0,     0,     0,     0,    29,    30,    31,     0,     0,
       0,     0,     0,     0,    32,    33,    34,    35,     0,     0,
       0,     0,     0,     1,     2,     3,     4,     5,     0,     0,
      36,     6,     7,     0,     8,     0,     9,   -16,     0,    10,
      11,    12,    37,    38,    39,    40,    13,     0,    41,     0,
       0,    42,     0,    14,     0,     0,    15,    16,    17,    18,
      19,    20,     0,    21,    22,     0,    23,     0,     0,     0,
      24,    25,     0,    26,    27,    28,     0,     0,     0,     0,
       0,     0,     0,     0,    29,    30,    31,     0,     0,     0,
       0,     0,     0,    32,    33,    34,    35,     0,     0,     0,
       0,     0,     1,     2,     3,     4,     5,     0,     0,    36,
       6,     7,     0,     8,     0,     9,   -17,     0,    10,    11,
      12,    37,    38,    39,    40,    13,     0,    41,     0,     0,
      42,     0,    14,     0,     0,    15,    16,    17,    18,    19,
      20,     0,    21,    22,     0,    23,     0,     0,     0,    24,
      25,     0,    26,    27,    28,     0,     0,     0,     0,     0,
       0,     0,     0,    29,    30,    31,     0,     0,     0,     0,
       0,     0,    32,    33,    34,    35,     0,     0,     0,     0,
       0,     1,     2,     3,     4,     5,     0,     0,    36,     6,
       7,     0,     8,     0,     9,     0,     0,    10,    11,    12,
      37,    38,    39,    40,    13,     0,    41,     0,     0,    42,
       0,    14,     0,     0,    15,    16,    17,    18,    19,    20,
       0,    21,    22,     0,    23,     0,     0,     0,    24,    25,
       0,    26,    27,    28,     0,     0,     0,     0,     0,     0,
       0,     0,    29,    30,    31,     0,     0,     0,     0,     0,
       0,    32,    33,    34,    35,     0,     0,     0,     0,     0,
       1,     2,     3,     4,     5,     0,     0,    36,     6,     7,
       0,     8,     0,     9,    89,     0,    10,    11,    12,    37,
      38,    39,    40,    13,     0,    41,     0,     0,    42,     0,
      14,     0,     0,    15,    16,    17,    18,    19,    20,     0,
       0,    22,     0,    23,     0,     0,     0,    24,    25,     0,
      26,    27,    28,     0,     0,     0,     0,     0,     0,     0,
       0,    29,    30,    31,     0,     0,     0,     0,     0,     0,
      32,    33,    34,    35,     0,     0,     1,     2,     3,     4,
       5,     0,     0,     0,     6,     7,    36,     8,     0,     9,
     188,     0,    10,    11,    12,     0,     0,     0,     0,    13,
       0,    40,     0,     0,    41,     0,    14,    42,     0,    15,
      16,    17,    18,    19,    20,     0,     0,    22,     0,    23,
       0,     0,     0,    24,    25,     0,    26,    27,    28,     0,
       0,     0,     0,     0,     0,     0,     0,    29,    30,    31,
       0,     0,     0,     0,     0,     0,    32,    33,    34,    35,
       0,     0,     1,     2,     3,     4,     5,     0,     0,     0,
       6,     7,    36,     8,     0,     9,     0,     0,    10,    11,
      12,     0,     0,     0,     0,    13,     0,    40,     0,     0,
      41,     0,    14,    42,     0,    15,    16,    17,    18,    19,
      20,     0,     0,    22,     0,    23,     0,     0,     0,    24,
      25,     0,    26,    27,    28,     0,     0,     0,     0,     0,
       0,     0,     0,    29,    30,    31,     0,     1,     2,     3,
       4,     5,    32,    33,    34,    35,     7,    86,     8,     0,
       0,     0,     0,    10,    11,    12,     0,     0,    36,     0,
      13,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    40,     0,     0,    41,     0,     0,    42,
      23,     0,     0,     0,    24,    25,     0,    26,    27,    28,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    30,
      31,     0,     0,     0,     0,     0,     0,    32,    33,    34,
      35,     1,     2,     3,     4,     5,     0,     0,     0,   100,
       7,     0,     8,    36,     0,     0,     0,    10,    11,    12,
       0,     0,     0,     0,    13,     0,     0,     0,    40,     0,
       0,    41,     0,     0,    42,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    23,     0,     0,     0,    24,    25,
       0,    26,    27,    28,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    30,    31,     0,     0,     0,     0,     0,
       0,    32,    33,    34,    35,     1,     2,     3,     4,     5,
       0,     0,     0,     6,     7,     0,     8,    36,     0,     0,
       0,    10,    11,    12,     0,     0,     0,     0,    13,     0,
       0,     0,    40,     0,     0,    41,     0,     0,    42,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    23,     0,
       0,     0,    24,    25,     0,    26,    27,    28,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    30,    31,     0,
       1,     2,     3,     4,     5,    32,    33,    34,    35,     7,
     248,     8,     0,     0,     0,     0,    10,    11,    12,     0,
       0,    36,     0,    13,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    40,     0,     0,    41,
       0,     0,    42,    23,     0,     0,     0,    24,    25,     0,
      26,    27,    28,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    30,    31,     0,     1,     2,     3,     4,     5,
      32,    33,    34,    35,     7,     0,     8,   251,     0,     0,
       0,    10,    11,    12,     0,     0,    36,     0,    13,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    40,     0,     0,    41,     0,     0,    42,    23,     0,
       0,     0,    24,    25,     0,    26,    27,    28,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    30,    31,     0,
       1,     2,     3,     4,     5,    32,    33,    34,    35,     7,
     263,     8,     0,     0,     0,     0,    10,    11,    12,     0,
       0,    36,     0,    13,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    40,     0,     0,    41,
       0,     0,    42,    23,     0,     0,     0,    24,    25,     0,
      26,    27,    28,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    30,    31,     0,     1,     2,     3,     4,     5,
      32,    33,    34,    35,     7,   265,     8,     0,     0,     0,
       0,    10,    11,    12,     0,     0,    36,     0,    13,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    40,     0,     0,    41,     0,     0,    42,    23,     0,
       0,     0,    24,    25,     0,    26,    27,    28,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    30,    31,     0,
       1,     2,     3,     4,     5,    32,    33,    34,    35,     7,
       0,     8,   267,     0,     0,     0,    10,    11,    12,     0,
       0,    36,     0,    13,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    40,     0,     0,    41,
       0,     0,    42,    23,     0,     0,     0,    24,    25,     0,
      26,    27,    28,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    30,    31,     0,     1,     2,     3,     4,     5,
      32,    33,    34,    35,     7,   293,     8,     0,     0,     0,
       0,    10,    11,    12,     0,     0,    36,     0,    13,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    40,     0,     0,    41,     0,     0,    42,    23,     0,
       0,     0,    24,    25,     0,    26,    27,    28,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    30,    31,     0,
       1,     2,     3,     4,     5,    32,    33,    34,    35,     7,
       0,     8,     0,     0,     0,     0,    10,    11,    12,     0,
       0,    36,     0,    13,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    40,     0,     0,    41,
       0,     0,    42,    23,     0,     0,     0,    24,    25,     0,
      26,    27,    28,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    30,    31,     0,   102,     2,     3,     4,     5,
      32,    33,    34,    35,     7,     0,     8,     0,     0,     0,
       0,    10,    11,    12,     0,     0,    36,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    40,     0,     0,    41,     0,     0,    42,    23,     0,
       0,     0,    24,    25,     0,    26,    27,    28,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    32,    33,    34,     0,     0,
       0,     0,     0,     0,     0,   326,     0,     0,     0,     0,
       0,    36,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,     0,     0,     0,    41,
       0,     0,    42,     0,     0,     0,     0,     0,     0,   341,
     342,   343,   344,   345,   346,   347,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   348,     0,     0,     0,     0,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,     0,   364,     0,   365,   366,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   367,   368,   420,     0,   369,   370,   371,   372,     0,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   341,   342,   343,
     344,   345,   346,   347,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   348,     0,     0,     0,     0,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,     0,   364,     0,   365,   366,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   367,
     368,     0,     0,   369,   370,   371,   372,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   341,   342,   343,   344,   345,   346,
     347,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     348,     0,     0,     0,     0,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
       0,   364,     0,   365,   366,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   367,   368,     0,     0,
     369,   370,   371,   372
};

static const yytype_int16 yycheck[] =
{
      30,    31,    32,    17,   125,     7,     8,   189,   278,     3,
      40,   281,    83,    51,   219,    95,     9,     3,    16,     0,
      22,   326,   133,     3,    26,    27,    28,    12,    16,    97,
      98,     3,   275,     9,     0,    36,     0,    12,    52,    15,
      42,   112,     3,     9,   115,    12,    26,    14,    97,    98,
     320,    18,   322,   323,    26,    24,    25,     3,     4,     5,
       6,     7,    43,    64,    33,    34,    12,    12,    14,    14,
      11,   314,   110,   111,   317,   186,    90,    43,   283,    43,
     118,   119,     3,    50,    51,    71,    71,    97,    98,    31,
     272,    93,    94,    95,     3,    97,    76,    21,    22,    23,
     130,    99,   100,    45,    13,    26,   108,    53,    54,    55,
     415,    99,    81,   193,    12,   420,   187,    26,   111,     3,
     325,   326,   116,     3,   394,   395,    11,     3,     9,    13,
      12,    16,    13,    13,   108,   109,    11,    13,   112,   113,
     114,   115,    26,    11,   414,    12,    26,   177,    16,   270,
      26,   421,   273,   423,    12,   276,   158,    89,   428,   429,
      47,   104,   105,     9,   110,     9,     9,    13,     9,    13,
      13,    30,    13,   211,   117,   118,   247,     9,   180,     9,
     251,    13,     9,    13,     3,   390,    13,     9,   218,   219,
      89,    13,   263,     9,   265,   400,     9,    13,     9,     9,
      13,    11,    13,   205,   386,   207,   208,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,   422,     9,     9,
      90,    11,    13,    93,     9,    95,    96,     9,    13,    49,
     301,    13,   303,    26,    27,    28,    29,   165,   166,   167,
     168,   255,   256,     9,    10,    11,    48,   261,   262,    52,
     173,   174,   175,   283,    91,   257,   258,   259,   260,    12,
      18,    14,    24,    25,   385,    28,    87,    88,    19,    20,
       9,    10,   163,   164,   169,   170,    71,   171,   172,   293,
       9,     3,    12,     3,    12,    71,    12,    14,    12,    14,
       9,    14,    35,   100,    15,   325,   326,   311,     3,    16,
      16,    16,    13,    13,    12,    17,    15,    99,     9,    13,
      17,    17,    12,    11,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    11,    17,
      43,    13,    13,    13,    12,   149,    13,    13,    13,   309,
     279,    46,    47,    48,    49,    50,    51,    52,   221,   157,
     156,   288,   161,   176,   159,   179,   160,    -1,    -1,    -1,
     390,   375,   162,   377,   378,    -1,    -1,    72,    -1,    -1,
     400,    -1,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    -1,    93,    -1,
      95,    96,   422,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   108,   109,    -1,    -1,   112,   113,   114,
     115,     0,    -1,    -1,     3,     4,     5,     6,     7,    -1,
      -1,    -1,    11,    12,    -1,    14,    -1,    16,    -1,    -1,
      19,    20,    21,    -1,    -1,    -1,    -1,    26,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    -1,    -1,    36,    37,    38,
      39,    40,    41,    -1,    43,    44,    -1,    46,    -1,    -1,
      -1,    50,    51,    -1,    53,    54,    55,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    64,    65,    66,    -1,    -1,
      -1,    -1,    -1,    -1,    73,    74,    75,    76,    -1,    -1,
      -1,    -1,    -1,     3,     4,     5,     6,     7,    -1,    -1,
      89,    11,    12,    -1,    14,    -1,    16,    17,    -1,    19,
      20,    21,   101,   102,   103,   104,    26,    -1,   107,    -1,
      -1,   110,    -1,    33,    -1,    -1,    36,    37,    38,    39,
      40,    41,    -1,    43,    44,    -1,    46,    -1,    -1,    -1,
      50,    51,    -1,    53,    54,    55,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    64,    65,    66,    -1,    -1,    -1,
      -1,    -1,    -1,    73,    74,    75,    76,    -1,    -1,    -1,
      -1,    -1,     3,     4,     5,     6,     7,    -1,    -1,    89,
      11,    12,    -1,    14,    -1,    16,    17,    -1,    19,    20,
      21,   101,   102,   103,   104,    26,    -1,   107,    -1,    -1,
     110,    -1,    33,    -1,    -1,    36,    37,    38,    39,    40,
      41,    -1,    43,    44,    -1,    46,    -1,    -1,    -1,    50,
      51,    -1,    53,    54,    55,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    64,    65,    66,    -1,    -1,    -1,    -1,
      -1,    -1,    73,    74,    75,    76,    -1,    -1,    -1,    -1,
      -1,     3,     4,     5,     6,     7,    -1,    -1,    89,    11,
      12,    -1,    14,    -1,    16,    -1,    -1,    19,    20,    21,
     101,   102,   103,   104,    26,    -1,   107,    -1,    -1,   110,
      -1,    33,    -1,    -1,    36,    37,    38,    39,    40,    41,
      -1,    43,    44,    -1,    46,    -1,    -1,    -1,    50,    51,
      -1,    53,    54,    55,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    64,    65,    66,    -1,    -1,    -1,    -1,    -1,
      -1,    73,    74,    75,    76,    -1,    -1,    -1,    -1,    -1,
       3,     4,     5,     6,     7,    -1,    -1,    89,    11,    12,
      -1,    14,    -1,    16,    17,    -1,    19,    20,    21,   101,
     102,   103,   104,    26,    -1,   107,    -1,    -1,   110,    -1,
      33,    -1,    -1,    36,    37,    38,    39,    40,    41,    -1,
      -1,    44,    -1,    46,    -1,    -1,    -1,    50,    51,    -1,
      53,    54,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    64,    65,    66,    -1,    -1,    -1,    -1,    -1,    -1,
      73,    74,    75,    76,    -1,    -1,     3,     4,     5,     6,
       7,    -1,    -1,    -1,    11,    12,    89,    14,    -1,    16,
      17,    -1,    19,    20,    21,    -1,    -1,    -1,    -1,    26,
      -1,   104,    -1,    -1,   107,    -1,    33,   110,    -1,    36,
      37,    38,    39,    40,    41,    -1,    -1,    44,    -1,    46,
      -1,    -1,    -1,    50,    51,    -1,    53,    54,    55,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,    65,    66,
      -1,    -1,    -1,    -1,    -1,    -1,    73,    74,    75,    76,
      -1,    -1,     3,     4,     5,     6,     7,    -1,    -1,    -1,
      11,    12,    89,    14,    -1,    16,    -1,    -1,    19,    20,
      21,    -1,    -1,    -1,    -1,    26,    -1,   104,    -1,    -1,
     107,    -1,    33,   110,    -1,    36,    37,    38,    39,    40,
      41,    -1,    -1,    44,    -1,    46,    -1,    -1,    -1,    50,
      51,    -1,    53,    54,    55,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    64,    65,    66,    -1,     3,     4,     5,
       6,     7,    73,    74,    75,    76,    12,    13,    14,    -1,
      -1,    -1,    -1,    19,    20,    21,    -1,    -1,    89,    -1,
      26,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   104,    -1,    -1,   107,    -1,    -1,   110,
      46,    -1,    -1,    -1,    50,    51,    -1,    53,    54,    55,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,
      66,    -1,    -1,    -1,    -1,    -1,    -1,    73,    74,    75,
      76,     3,     4,     5,     6,     7,    -1,    -1,    -1,    11,
      12,    -1,    14,    89,    -1,    -1,    -1,    19,    20,    21,
      -1,    -1,    -1,    -1,    26,    -1,    -1,    -1,   104,    -1,
      -1,   107,    -1,    -1,   110,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    46,    -1,    -1,    -1,    50,    51,
      -1,    53,    54,    55,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    65,    66,    -1,    -1,    -1,    -1,    -1,
      -1,    73,    74,    75,    76,     3,     4,     5,     6,     7,
      -1,    -1,    -1,    11,    12,    -1,    14,    89,    -1,    -1,
      -1,    19,    20,    21,    -1,    -1,    -1,    -1,    26,    -1,
      -1,    -1,   104,    -1,    -1,   107,    -1,    -1,   110,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    46,    -1,
      -1,    -1,    50,    51,    -1,    53,    54,    55,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    66,    -1,
       3,     4,     5,     6,     7,    73,    74,    75,    76,    12,
      13,    14,    -1,    -1,    -1,    -1,    19,    20,    21,    -1,
      -1,    89,    -1,    26,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   104,    -1,    -1,   107,
      -1,    -1,   110,    46,    -1,    -1,    -1,    50,    51,    -1,
      53,    54,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    65,    66,    -1,     3,     4,     5,     6,     7,
      73,    74,    75,    76,    12,    -1,    14,    15,    -1,    -1,
      -1,    19,    20,    21,    -1,    -1,    89,    -1,    26,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   104,    -1,    -1,   107,    -1,    -1,   110,    46,    -1,
      -1,    -1,    50,    51,    -1,    53,    54,    55,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    66,    -1,
       3,     4,     5,     6,     7,    73,    74,    75,    76,    12,
      13,    14,    -1,    -1,    -1,    -1,    19,    20,    21,    -1,
      -1,    89,    -1,    26,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   104,    -1,    -1,   107,
      -1,    -1,   110,    46,    -1,    -1,    -1,    50,    51,    -1,
      53,    54,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    65,    66,    -1,     3,     4,     5,     6,     7,
      73,    74,    75,    76,    12,    13,    14,    -1,    -1,    -1,
      -1,    19,    20,    21,    -1,    -1,    89,    -1,    26,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   104,    -1,    -1,   107,    -1,    -1,   110,    46,    -1,
      -1,    -1,    50,    51,    -1,    53,    54,    55,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    66,    -1,
       3,     4,     5,     6,     7,    73,    74,    75,    76,    12,
      -1,    14,    15,    -1,    -1,    -1,    19,    20,    21,    -1,
      -1,    89,    -1,    26,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   104,    -1,    -1,   107,
      -1,    -1,   110,    46,    -1,    -1,    -1,    50,    51,    -1,
      53,    54,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    65,    66,    -1,     3,     4,     5,     6,     7,
      73,    74,    75,    76,    12,    13,    14,    -1,    -1,    -1,
      -1,    19,    20,    21,    -1,    -1,    89,    -1,    26,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   104,    -1,    -1,   107,    -1,    -1,   110,    46,    -1,
      -1,    -1,    50,    51,    -1,    53,    54,    55,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    66,    -1,
       3,     4,     5,     6,     7,    73,    74,    75,    76,    12,
      -1,    14,    -1,    -1,    -1,    -1,    19,    20,    21,    -1,
      -1,    89,    -1,    26,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   104,    -1,    -1,   107,
      -1,    -1,   110,    46,    -1,    -1,    -1,    50,    51,    -1,
      53,    54,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    65,    66,    -1,     3,     4,     5,     6,     7,
      73,    74,    75,    76,    12,    -1,    14,    -1,    -1,    -1,
      -1,    19,    20,    21,    -1,    -1,    89,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   104,    -1,    -1,   107,    -1,    -1,   110,    46,    -1,
      -1,    -1,    50,    51,    -1,    53,    54,    55,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    73,    74,    75,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    12,    -1,    -1,    -1,    -1,
      -1,    89,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    -1,    -1,    -1,   107,
      -1,    -1,   110,    -1,    -1,    -1,    -1,    -1,    -1,    46,
      47,    48,    49,    50,    51,    52,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    72,    -1,    -1,    -1,    -1,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    -1,    93,    -1,    95,    96,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   108,   109,    12,    -1,   112,   113,   114,   115,    -1,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    46,    47,    48,
      49,    50,    51,    52,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    72,    -1,    -1,    -1,    -1,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    -1,    93,    -1,    95,    96,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   108,
     109,    -1,    -1,   112,   113,   114,   115,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    46,    47,    48,    49,    50,    51,
      52,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      72,    -1,    -1,    -1,    -1,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      -1,    93,    -1,    95,    96,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   108,   109,    -1,    -1,
     112,   113,   114,   115
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     3,     4,     5,     6,     7,    11,    12,    14,    16,
      19,    20,    21,    26,    33,    36,    37,    38,    39,    40,
      41,    43,    44,    46,    50,    51,    53,    54,    55,    64,
      65,    66,    73,    74,    75,    76,    89,   101,   102,   103,
     104,   107,   110,   120,   121,   122,   130,   131,   132,   134,
     135,   136,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   151,   154,   155,   156,   159,   160,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   171,
     172,   173,   175,   176,   177,    71,    13,   146,   146,    17,
     139,     3,   129,    12,    12,    12,   140,    12,    11,    11,
      11,   146,     3,   172,   172,   146,   146,   146,    12,     3,
     136,   136,   136,   172,   172,     3,   152,   153,    76,   136,
      89,   146,     0,   121,    97,    98,   104,   105,   117,   118,
     133,   152,   140,     9,    11,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    90,    93,    95,    96,   157,
     108,   109,   112,   113,   114,   115,   158,    31,    45,    30,
      47,    49,    48,    24,    25,    26,    27,    28,    29,    87,
      88,    19,    20,    21,    22,    23,    89,    52,   172,    91,
      12,    18,    50,    51,   149,    13,     9,    15,    17,    18,
      28,   146,   146,   145,   146,    36,    64,   146,    11,    13,
      13,    13,   146,   152,   152,    12,   149,    12,    14,   149,
     150,     9,   152,   152,   111,     3,   128,   128,    12,    12,
       3,   136,   137,   147,   148,   151,   161,   146,   162,   163,
     164,   165,   166,   166,   167,   167,   167,   167,   168,   168,
     169,   169,   170,   170,   170,   171,   136,   176,    13,   146,
       3,    15,   149,   129,    71,    13,    13,   145,    10,    12,
      12,    13,    13,    13,   146,    13,   146,    15,    14,   152,
       9,    16,    99,   100,   123,    16,    99,   127,    13,   136,
     138,    13,   138,    12,    14,   150,     3,   116,    10,    13,
     149,   140,   140,    13,   146,   146,   146,   146,   140,   140,
     149,    13,   149,    13,    15,   128,   122,   124,   125,   126,
     130,   139,   129,   128,    16,   124,   128,    16,   144,   153,
      13,   144,    13,    13,   138,    12,    12,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    46,    47,    48,    49,    50,    51,    52,    72,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    93,    95,    96,   108,   109,   112,
     113,   114,   115,   174,   159,    35,   140,    13,    13,    13,
      13,   149,   149,    17,   125,   100,    99,   124,    17,   124,
       9,   144,   144,   144,    13,    13,   138,    26,   138,   174,
      12,   140,   140,   140,    11,    11,   128,   129,    17,    17,
     138,   144,    11,   144,    13,    13,    13,   138,    11,   144,
      12,   174,    12,    13,   174,   144,   138,   144,    13,    13,
     144,   144
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_uint8 yyr1[] =
{
       0,   119,   120,   120,   121,   121,   121,   122,   122,   122,
     122,   123,   123,   123,   123,   124,   124,   125,   125,   126,
     126,   126,   127,   128,   128,   129,   129,   130,   130,   130,
     130,   130,   130,   130,   130,   130,   130,   130,   130,   130,
     130,   131,   131,   131,   132,   132,   132,   132,   133,   133,
     133,   134,   134,   135,   135,   136,   136,   137,   137,   138,
     138,   139,   139,   140,   140,   140,   140,   140,   141,   141,
     141,   141,   142,   142,   143,   143,   143,   143,   143,   143,
     143,   143,   144,   144,   145,   145,   146,   146,   147,   147,
     148,   148,   149,   149,   149,   149,   150,   150,   151,   151,
     151,   151,   151,   151,   151,   152,   152,   153,   153,   153,
     153,   153,   153,   153,   154,   155,   156,   157,   157,   157,
     157,   157,   157,   157,   157,   157,   157,   157,   157,   157,
     157,   158,   158,   158,   158,   158,   158,   159,   159,   160,
     160,   161,   161,   162,   162,   163,   163,   164,   164,   165,
     165,   165,   166,   166,   166,   166,   166,   167,   167,   167,
     168,   168,   168,   169,   169,   169,   169,   170,   170,   171,
     171,   172,   172,   172,   172,   172,   172,   172,   172,   172,
     172,   172,   172,   173,   173,   173,   173,   173,   173,   174,
     174,   174,   174,   174,   174,   174,   174,   174,   174,   174,
     174,   174,   174,   174,   174,   174,   174,   174,   174,   174,
     174,   174,   174,   174,   174,   174,   174,   174,   174,   174,
     174,   174,   174,   174,   174,   174,   174,   174,   174,   174,
     174,   174,   174,   174,   174,   175,   175,   176,   176,   176,
     176,   176,   176,   176,   177,   177,   177,   177,   177,   177,
     177,   177,   177,   177,   177,   177
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     1,     2,     1,     1,     1,     6,     7,     6,
       7,     2,     4,     2,     4,     1,     0,     1,     2,     1,
       1,     1,     2,     1,     3,     1,     3,     8,     7,     7,
       6,     6,     5,     5,     6,     8,     7,     9,     9,    11,
      11,     1,     1,     0,     1,     1,     1,     1,     1,     1,
       0,     1,     2,     3,     4,     1,     1,     1,     2,     2,
       4,     1,     2,     1,     1,     1,     1,     1,     2,     3,
       2,     2,     5,     7,     5,     7,     6,     7,     7,     5,
       7,     5,     2,     3,     1,     2,     1,     3,     1,     3,
       1,     3,     3,     4,     4,     5,     2,     3,     1,     2,
       3,     3,     3,     2,     3,     1,     3,     1,     2,     2,
       3,     4,     4,     5,     3,     3,     3,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     5,     1,
       3,     1,     3,     1,     3,     1,     3,     1,     3,     1,
       3,     3,     1,     3,     3,     3,     3,     1,     3,     3,
       1,     3,     3,     1,     3,     3,     3,     1,     3,     1,
       3,     1,     2,     2,     2,     2,     2,     2,     3,     4,
       5,     5,     6,     1,     1,     1,     1,     1,     2,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     3,     1,     2,     3,
       4,     3,     2,     2,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     3,     3,     2
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF

/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (0)
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)


/* YYLOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

# ifndef YYLOCATION_PRINT

#  if defined YY_LOCATION_PRINT

   /* Temporary convenience wrapper in case some people defined the
      undocumented and private YY_LOCATION_PRINT macros.  */
#   define YYLOCATION_PRINT(File, Loc)  YY_LOCATION_PRINT(File, *(Loc))

#  elif defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

YY_ATTRIBUTE_UNUSED
static int
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
{
  int res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += YYFPRINTF (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += YYFPRINTF (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += YYFPRINTF (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += YYFPRINTF (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += YYFPRINTF (yyo, "-%d", end_col);
    }
  return res;
}

#   define YYLOCATION_PRINT  yy_location_print_

    /* Temporary convenience wrapper in case some people defined the
       undocumented and private YY_LOCATION_PRINT macros.  */
#   define YY_LOCATION_PRINT(File, Loc)  YYLOCATION_PRINT(File, &(Loc))

#  else

#   define YYLOCATION_PRINT(File, Loc) ((void) 0)
    /* Temporary convenience wrapper in case some people defined the
       undocumented and private YY_LOCATION_PRINT macros.  */
#   define YY_LOCATION_PRINT  YYLOCATION_PRINT

#  endif
# endif /* !defined YYLOCATION_PRINT */


# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value, Location); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  YY_USE (yylocationp);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  YYLOCATION_PRINT (yyo, yylocationp);
  YYFPRINTF (yyo, ": ");
  yy_symbol_value_print (yyo, yykind, yyvaluep, yylocationp);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp, YYLTYPE *yylsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)],
                       &(yylsp[(yyi + 1) - (yynrhs)]));
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, yylsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep, YYLTYPE *yylocationp)
{
  YY_USE (yyvaluep);
  YY_USE (yylocationp);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Location data for the lookahead symbol.  */
YYLTYPE yylloc
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

    /* The location stack: array, bottom, top.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls = yylsa;
    YYLTYPE *yylsp = yyls;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

  /* The locations where the error started and ended.  */
  YYLTYPE yyerror_range[3];



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  yylsp[0] = yylloc;
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;
        YYLTYPE *yyls1 = yyls;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yyls1, yysize * YYSIZEOF (*yylsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
        yyls = yyls1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
        YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      yyerror_range[1] = yylloc;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location. */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  yyerror_range[1] = yyloc;
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2: /* program: program_section  */
#line 206 "chuck.y"
                                            { (yyval.program) = g_program = new_program( (yyvsp[0].program_section), (yylsp[0]).first_line, (yylsp[0]).first_column ); }
#line 2052 "chuck.tab.c"
    break;

  case 3: /* program: program program_section  */
#line 207 "chuck.y"
                                            { (yyval.program) = g_program = append_program( (yyvsp[-1].program), (yyvsp[0].program_section), (yylsp[-1]).first_line, (yylsp[-1]).first_column ); }
#line 2058 "chuck.tab.c"
    break;

  case 4: /* program_section: statement_list  */
#line 211 "chuck.y"
                                            { (yyval.program_section) = new_section_stmt( (yyvsp[0].stmt_list), (yylsp[0]).first_line, (yylsp[0]).first_column ); }
#line 2064 "chuck.tab.c"
    break;

  case 5: /* program_section: function_definition  */
#line 212 "chuck.y"
                                            { (yyval.program_section) = new_section_func_def( (yyvsp[0].func_def), (yylsp[0]).first_line, (yylsp[0]).first_column ); }
#line 2070 "chuck.tab.c"
    break;

  case 6: /* program_section: class_definition  */
#line 213 "chuck.y"
                                            { (yyval.program_section) = new_section_class_def( (yyvsp[0].class_def), (yylsp[0]).first_line, (yylsp[0]).first_column ); }
#line 2076 "chuck.tab.c"
    break;

  case 7: /* class_definition: class_decl CLASS id_list LBRACE class_body RBRACE  */
#line 218 "chuck.y"
            { (yyval.class_def) = new_class_def( (yyvsp[-5].ival), (yyvsp[-3].id_list), NULL, (yyvsp[-1].class_body), (yylsp[-5]).first_line, (yylsp[-5]).first_column ); }
#line 2082 "chuck.tab.c"
    break;

  case 8: /* class_definition: class_decl CLASS id_list class_ext LBRACE class_body RBRACE  */
#line 220 "chuck.y"
            { (yyval.class_def) = new_class_def( (yyvsp[-6].ival), (yyvsp[-4].id_list), (yyvsp[-3].class_ext), (yyvsp[-1].class_body), (yylsp[-6]).first_line, (yylsp[-6]).first_column ); }
#line 2088 "chuck.tab.c"
    break;

  case 9: /* class_definition: class_decl INTERFACE id_list LBRACE class_body RBRACE  */
#line 222 "chuck.y"
            { (yyval.class_def) = new_iface_def( (yyvsp[-5].ival), (yyvsp[-3].id_list), NULL, (yyvsp[-1].class_body), (yylsp[-5]).first_line, (yylsp[-5]).first_column ); }
#line 2094 "chuck.tab.c"
    break;

  case 10: /* class_definition: class_decl INTERFACE id_list iface_ext LBRACE class_body RBRACE  */
#line 224 "chuck.y"
            { (yyval.class_def) = new_iface_def( (yyvsp[-6].ival), (yyvsp[-4].id_list), (yyvsp[-3].class_ext), (yyvsp[-1].class_body), (yylsp[-6]).first_line, (yylsp[-6]).first_column ); }
#line 2100 "chuck.tab.c"
    break;

  case 11: /* class_ext: IMPLEMENTS id_list  */
#line 228 "chuck.y"
                                            { (yyval.class_ext) = new_class_ext( NULL, (yyvsp[0].id_list), (yylsp[-1]).first_line, (yylsp[-1]).first_column ); }
#line 2106 "chuck.tab.c"
    break;

  case 12: /* class_ext: IMPLEMENTS id_list EXTENDS id_dot  */
#line 229 "chuck.y"
                                            { (yyval.class_ext) = new_class_ext( (yyvsp[0].id_list), (yyvsp[-2].id_list), (yylsp[-3]).first_line, (yylsp[-3]).first_column ); }
#line 2112 "chuck.tab.c"
    break;

  case 13: /* class_ext: EXTENDS id_dot  */
#line 230 "chuck.y"
                                            { (yyval.class_ext) = new_class_ext( (yyvsp[0].id_list), NULL, (yylsp[-1]).first_line, (yylsp[-1]).first_column ); }
#line 2118 "chuck.tab.c"
    break;

  case 14: /* class_ext: EXTENDS id_dot IMPLEMENTS id_list  */
#line 231 "chuck.y"
                                            { (yyval.class_ext) = new_class_ext( (yyvsp[-2].id_list), (yyvsp[0].id_list), (yylsp[-3]).first_line, (yylsp[-3]).first_column ); }
#line 2124 "chuck.tab.c"
    break;

  case 15: /* class_body: class_body2  */
#line 235 "chuck.y"
                                            { (yyval.class_body) = (yyvsp[0].class_body); }
#line 2130 "chuck.tab.c"
    break;

  case 16: /* class_body: %empty  */
#line 236 "chuck.y"
                                                    { (yyval.class_body) = NULL; }
#line 2136 "chuck.tab.c"
    break;

  case 17: /* class_body2: class_section  */
#line 240 "chuck.y"
                                            { (yyval.class_body) = new_class_body( (yyvsp[0].program_section), (yylsp[0]).first_line, (yylsp[0]).first_column ); }
#line 2142 "chuck.tab.c"
    break;

  case 18: /* class_body2: class_section class_body2  */
#line 241 "chuck.y"
                                            { (yyval.class_body) = prepend_class_body( (yyvsp[-1].program_section), (yyvsp[0].class_body), (yylsp[-1]).first_line, (yylsp[-1]).first_column ); }
#line 2148 "chuck.tab.c"
    break;

  case 19: /* class_section: statement_list  */
#line 246 "chuck.y"
                                            { (yyval.program_section) = new_section_stmt( (yyvsp[0].stmt_list), (yylsp[0]).first_line, (yylsp[0]).first_column ); }
#line 2154 "chuck.tab.c"
    break;

  case 20: /* class_section: function_definition  */
#line 247 "chuck.y"
                                            { (yyval.program_section) = new_section_func_def( (yyvsp[0].func_def), (yylsp[0]).first_line, (yylsp[0]).first_column ); }
#line 2160 "chuck.tab.c"
    break;

  case 21: /* class_section: class_definition  */
#line 248 "chuck.y"
                                            { (yyval.program_section) = new_section_class_def( (yyvsp[0].class_def), (yylsp[0]).first_line, (yylsp[0]).first_column ); }
#line 2166 "chuck.tab.c"
    break;

  case 22: /* iface_ext: EXTENDS id_list  */
#line 252 "chuck.y"
                                            { (yyval.class_ext) = new_class_ext( NULL, (yyvsp[0].id_list), (yylsp[-1]).first_line, (yylsp[-1]).first_column ); }
#line 2172 "chuck.tab.c"
    break;

  case 23: /* id_list: ID  */
#line 256 "chuck.y"
                                            { (yyval.id_list) = new_id_list( (yyvsp[0].sval), (yylsp[0]).first_line, (yylsp[0]).first_column  /*, &@1 */ ); }
#line 2178 "chuck.tab.c"
    break;

  case 24: /* id_list: ID COMMA id_list  */
#line 257 "chuck.y"
                                            { (yyval.id_list) = prepend_id_list( (yyvsp[-2].sval), (yyvsp[0].id_list), (yylsp[-2]).first_line, (yylsp[-2]).first_column  /*, &@1 */ ); }
#line 2184 "chuck.tab.c"
    break;

  case 25: /* id_dot: ID  */
#line 261 "chuck.y"
                                            { (yyval.id_list) = new_id_list( (yyvsp[0].sval), (yylsp[0]).first_line, (yylsp[0]).first_column  /*, &@1*/ ); }
#line 2190 "chuck.tab.c"
    break;

  case 26: /* id_dot: ID DOT id_dot  */
#line 262 "chuck.y"
                                            { (yyval.id_list) = prepend_id_list( (yyvsp[-2].sval), (yyvsp[0].id_list), (yylsp[-2]).first_line, (yylsp[-2]).first_column  /*, &@1*/ ); }
#line 2196 "chuck.tab.c"
    break;

  case 27: /* function_definition: function_decl static_decl type_decl2 ID LPAREN arg_list RPAREN code_segment  */
#line 267 "chuck.y"
            { (yyval.func_def) = new_func_def( (yyvsp[-7].ival), (yyvsp[-6].ival), (yyvsp[-5].type_decl), (yyvsp[-4].sval), (yyvsp[-2].arg_list), (yyvsp[0].stmt), TRUE, (yylsp[-7]).first_line, (yylsp[-7]).first_column ); }
#line 2202 "chuck.tab.c"
    break;

  case 28: /* function_definition: function_decl static_decl type_decl2 ID LPAREN RPAREN code_segment  */
#line 269 "chuck.y"
            { (yyval.func_def) = new_func_def( (yyvsp[-6].ival), (yyvsp[-5].ival), (yyvsp[-4].type_decl), (yyvsp[-3].sval), NULL, (yyvsp[0].stmt), TRUE, (yylsp[-6]).first_line, (yylsp[-6]).first_column ); }
#line 2208 "chuck.tab.c"
    break;

  case 29: /* function_definition: function_decl static_decl ID LPAREN arg_list RPAREN code_segment  */
#line 271 "chuck.y"
            { (yyval.func_def) = new_func_def( (yyvsp[-6].ival), (yyvsp[-5].ival), NULL, (yyvsp[-4].sval), (yyvsp[-2].arg_list), (yyvsp[0].stmt), TRUE, (yylsp[-6]).first_line, (yylsp[-6]).first_column ); }
#line 2214 "chuck.tab.c"
    break;

  case 30: /* function_definition: function_decl static_decl ID LPAREN RPAREN code_segment  */
#line 273 "chuck.y"
            { (yyval.func_def) = new_func_def( (yyvsp[-5].ival), (yyvsp[-4].ival), NULL, (yyvsp[-3].sval), NULL, (yyvsp[0].stmt), TRUE, (yylsp[-5]).first_line, (yylsp[-5]).first_column ); }
#line 2220 "chuck.tab.c"
    break;

  case 31: /* function_definition: function_decl AT_CTOR LPAREN arg_list RPAREN code_segment  */
#line 275 "chuck.y"
            { (yyval.func_def) = new_func_def( (yyvsp[-5].ival), ae_key_instance, NULL, "@construct", (yyvsp[-2].arg_list), (yyvsp[0].stmt), TRUE, (yylsp[-5]).first_line, (yylsp[-5]).first_column ); }
#line 2226 "chuck.tab.c"
    break;

  case 32: /* function_definition: function_decl AT_CTOR LPAREN RPAREN code_segment  */
#line 277 "chuck.y"
            { (yyval.func_def) = new_func_def( (yyvsp[-4].ival), ae_key_instance, NULL, "@construct", NULL, (yyvsp[0].stmt), TRUE, (yylsp[-4]).first_line, (yylsp[-4]).first_column ); }
#line 2232 "chuck.tab.c"
    break;

  case 33: /* function_definition: function_decl AT_DTOR LPAREN RPAREN code_segment  */
#line 279 "chuck.y"
            { (yyval.func_def) = new_func_def( (yyvsp[-4].ival), ae_key_instance, NULL, "@destruct", NULL, (yyvsp[0].stmt), TRUE, (yylsp[-4]).first_line, (yylsp[-4]).first_column ); }
#line 2238 "chuck.tab.c"
    break;

  case 34: /* function_definition: function_decl AT_DTOR LPAREN arg_list RPAREN code_segment  */
#line 281 "chuck.y"
            { (yyval.func_def) = new_func_def( (yyvsp[-5].ival), ae_key_instance, NULL, "@destruct", (yyvsp[-2].arg_list), (yyvsp[0].stmt), TRUE, (yylsp[-5]).first_line, (yylsp[-5]).first_column ); }
#line 2244 "chuck.tab.c"
    break;

  case 35: /* function_definition: function_decl static_decl type_decl2 ID LPAREN arg_list RPAREN SEMICOLON  */
#line 283 "chuck.y"
            { (yyval.func_def) = new_func_def( (yyvsp[-7].ival), (yyvsp[-6].ival), (yyvsp[-5].type_decl), (yyvsp[-4].sval), (yyvsp[-2].arg_list), NULL, TRUE, (yylsp[-7]).first_line, (yylsp[-7]).first_column ); }
#line 2250 "chuck.tab.c"
    break;

  case 36: /* function_definition: function_decl static_decl type_decl2 ID LPAREN RPAREN SEMICOLON  */
#line 285 "chuck.y"
            { (yyval.func_def) = new_func_def( (yyvsp[-6].ival), (yyvsp[-5].ival), (yyvsp[-4].type_decl), (yyvsp[-3].sval), NULL, NULL, TRUE, (yylsp[-6]).first_line, (yylsp[-6]).first_column ); }
#line 2256 "chuck.tab.c"
    break;

  case 37: /* function_definition: function_decl static_decl type_decl2 AT_OP overloadable_operator LPAREN arg_list RPAREN code_segment  */
#line 287 "chuck.y"
            { (yyval.func_def) = new_op_overload( (yyvsp[-8].ival), (yyvsp[-7].ival), (yyvsp[-6].type_decl), (yyvsp[-4].ival), (yyvsp[-2].arg_list), (yyvsp[0].stmt), TRUE, FALSE, (yylsp[-8]).first_line, (yylsp[-8]).first_column, (yylsp[-4]).first_column ); }
#line 2262 "chuck.tab.c"
    break;

  case 38: /* function_definition: function_decl static_decl type_decl2 AT_OP LPAREN arg_list RPAREN overloadable_operator code_segment  */
#line 289 "chuck.y"
            { (yyval.func_def) = new_op_overload( (yyvsp[-8].ival), (yyvsp[-7].ival), (yyvsp[-6].type_decl), (yyvsp[-1].ival), (yyvsp[-3].arg_list), (yyvsp[0].stmt), TRUE, TRUE, (yylsp[-8]).first_line, (yylsp[-8]).first_column, (yylsp[-1]).first_column ); }
#line 2268 "chuck.tab.c"
    break;

  case 39: /* function_definition: function_decl static_decl type_decl2 AT_OP LPAREN overloadable_operator RPAREN LPAREN arg_list RPAREN code_segment  */
#line 291 "chuck.y"
            { (yyval.func_def) = new_op_overload( (yyvsp[-10].ival), (yyvsp[-9].ival), (yyvsp[-8].type_decl), (yyvsp[-5].ival), (yyvsp[-2].arg_list), (yyvsp[0].stmt), TRUE, FALSE, (yylsp[-10]).first_line, (yylsp[-10]).first_column, (yylsp[-6]).first_column ); }
#line 2274 "chuck.tab.c"
    break;

  case 40: /* function_definition: function_decl static_decl type_decl2 AT_OP LPAREN arg_list RPAREN LPAREN overloadable_operator RPAREN code_segment  */
#line 293 "chuck.y"
            { (yyval.func_def) = new_op_overload( (yyvsp[-10].ival), (yyvsp[-9].ival), (yyvsp[-8].type_decl), (yyvsp[-2].ival), (yyvsp[-5].arg_list), (yyvsp[0].stmt), TRUE, TRUE, (yylsp[-10]).first_line, (yylsp[-10]).first_column, (yylsp[-3]).first_column ); }
#line 2280 "chuck.tab.c"
    break;

  case 41: /* class_decl: PUBLIC  */
#line 297 "chuck.y"
                                            { (yyval.ival) = ae_key_public; }
#line 2286 "chuck.tab.c"
    break;

  case 42: /* class_decl: PRIVATE  */
#line 298 "chuck.y"
                                            { (yyval.ival) = ae_key_private; }
#line 2292 "chuck.tab.c"
    break;

  case 43: /* class_decl: %empty  */
#line 299 "chuck.y"
                                            { (yyval.ival) = ae_key_private; }
#line 2298 "chuck.tab.c"
    break;

  case 44: /* function_decl: FUNCTION  */
#line 303 "chuck.y"
                                            { (yyval.ival) = ae_key_func; }
#line 2304 "chuck.tab.c"
    break;

  case 45: /* function_decl: PUBLIC  */
#line 304 "chuck.y"
                                            { (yyval.ival) = ae_key_public; }
#line 2310 "chuck.tab.c"
    break;

  case 46: /* function_decl: PROTECTED  */
#line 305 "chuck.y"
                                            { (yyval.ival) = ae_key_protected; }
#line 2316 "chuck.tab.c"
    break;

  case 47: /* function_decl: PRIVATE  */
#line 306 "chuck.y"
                                            { (yyval.ival) = ae_key_private; }
#line 2322 "chuck.tab.c"
    break;

  case 48: /* static_decl: STATIC  */
#line 310 "chuck.y"
                                            { (yyval.ival) = ae_key_static; }
#line 2328 "chuck.tab.c"
    break;

  case 49: /* static_decl: ABSTRACT  */
#line 311 "chuck.y"
                                            { (yyval.ival) = ae_key_abstract; }
#line 2334 "chuck.tab.c"
    break;

  case 50: /* static_decl: %empty  */
#line 312 "chuck.y"
                                            { (yyval.ival) = ae_key_instance; }
#line 2340 "chuck.tab.c"
    break;

  case 51: /* type_decl_a: ID  */
#line 316 "chuck.y"
                                            { (yyval.type_decl) = new_type_decl( new_id_list( (yyvsp[0].sval), (yylsp[0]).first_line, (yylsp[0]).first_column /*, &@1*/ ), 0, (yylsp[0]).first_line, (yylsp[0]).first_column ); }
#line 2346 "chuck.tab.c"
    break;

  case 52: /* type_decl_a: ID AT_SYM  */
#line 317 "chuck.y"
                                            { (yyval.type_decl) = new_type_decl( new_id_list( (yyvsp[-1].sval), (yylsp[-1]).first_line, (yylsp[-1]).first_column /*, &@1*/ ), 1, (yylsp[-1]).first_line, (yylsp[-1]).first_column ); }
#line 2352 "chuck.tab.c"
    break;

  case 53: /* type_decl_b: LT id_dot GT  */
#line 321 "chuck.y"
                                            { (yyval.type_decl) = new_type_decl( (yyvsp[-1].id_list), 0, (yylsp[-2]).first_line, (yylsp[-2]).first_column ); }
#line 2358 "chuck.tab.c"
    break;

  case 54: /* type_decl_b: LT id_dot GT AT_SYM  */
#line 322 "chuck.y"
                                            { (yyval.type_decl) = new_type_decl( (yyvsp[-2].id_list), 1, (yylsp[-3]).first_line, (yylsp[-3]).first_column ); }
#line 2364 "chuck.tab.c"
    break;

  case 55: /* type_decl: type_decl_a  */
#line 331 "chuck.y"
                                            { (yyval.type_decl) = (yyvsp[0].type_decl); }
#line 2370 "chuck.tab.c"
    break;

  case 56: /* type_decl: type_decl_b  */
#line 332 "chuck.y"
                                            { (yyval.type_decl) = (yyvsp[0].type_decl); }
#line 2376 "chuck.tab.c"
    break;

  case 57: /* type_decl2: type_decl  */
#line 337 "chuck.y"
                                            { (yyval.type_decl) = (yyvsp[0].type_decl); }
#line 2382 "chuck.tab.c"
    break;

  case 58: /* type_decl2: type_decl array_empty  */
#line 338 "chuck.y"
                                            { (yyval.type_decl) = add_type_decl_array( (yyvsp[-1].type_decl), (yyvsp[0].array_sub), (yylsp[-1]).first_line, (yylsp[-1]).first_column ); }
#line 2388 "chuck.tab.c"
    break;

  case 59: /* arg_list: type_decl var_decl  */
#line 342 "chuck.y"
                                            { (yyval.arg_list) = new_arg_list( (yyvsp[-1].type_decl), (yyvsp[0].var_decl), (yylsp[-1]).first_line, (yylsp[-1]).first_column ); }
#line 2394 "chuck.tab.c"
    break;

  case 60: /* arg_list: type_decl var_decl COMMA arg_list  */
#line 343 "chuck.y"
                                            { (yyval.arg_list) = prepend_arg_list( (yyvsp[-3].type_decl), (yyvsp[-2].var_decl), (yyvsp[0].arg_list), (yylsp[-3]).first_line, (yylsp[-3]).first_column ); }
#line 2400 "chuck.tab.c"
    break;

  case 61: /* statement_list: statement  */
#line 347 "chuck.y"
                                            { (yyval.stmt_list) = new_stmt_list( (yyvsp[0].stmt), (yylsp[0]).first_line, (yylsp[0]).first_column ); }
#line 2406 "chuck.tab.c"
    break;

  case 62: /* statement_list: statement_list statement  */
#line 348 "chuck.y"
                                            { (yyval.stmt_list) = append_stmt_list( (yyvsp[-1].stmt_list), (yyvsp[0].stmt), (yylsp[-1]).first_line, (yylsp[-1]).first_column ); }
#line 2412 "chuck.tab.c"
    break;

  case 63: /* statement: expression_statement  */
#line 352 "chuck.y"
                                            { (yyval.stmt) = (yyvsp[0].stmt); }
#line 2418 "chuck.tab.c"
    break;

  case 64: /* statement: loop_statement  */
#line 353 "chuck.y"
                                            { (yyval.stmt) = (yyvsp[0].stmt); }
#line 2424 "chuck.tab.c"
    break;

  case 65: /* statement: selection_statement  */
#line 354 "chuck.y"
                                            { (yyval.stmt) = (yyvsp[0].stmt); }
#line 2430 "chuck.tab.c"
    break;

  case 66: /* statement: jump_statement  */
#line 355 "chuck.y"
                                            { (yyval.stmt) = (yyvsp[0].stmt); }
#line 2436 "chuck.tab.c"
    break;

  case 67: /* statement: code_segment  */
#line 357 "chuck.y"
                                            { (yyval.stmt) = (yyvsp[0].stmt); }
#line 2442 "chuck.tab.c"
    break;

  case 68: /* jump_statement: RETURN SEMICOLON  */
#line 361 "chuck.y"
                                            { (yyval.stmt) = new_stmt_from_return( NULL, (yylsp[-1]).first_line, (yylsp[-1]).first_column ); }
#line 2448 "chuck.tab.c"
    break;

  case 69: /* jump_statement: RETURN expression SEMICOLON  */
#line 362 "chuck.y"
                                            { (yyval.stmt) = new_stmt_from_return( (yyvsp[-1].exp), (yylsp[-2]).first_line, (yylsp[-2]).first_column ); }
#line 2454 "chuck.tab.c"
    break;

  case 70: /* jump_statement: BREAK SEMICOLON  */
#line 363 "chuck.y"
                                            { (yyval.stmt) = new_stmt_from_break( (yylsp[-1]).first_line, (yylsp[-1]).first_column ); }
#line 2460 "chuck.tab.c"
    break;

  case 71: /* jump_statement: CONTINUE SEMICOLON  */
#line 364 "chuck.y"
                                            { (yyval.stmt) = new_stmt_from_continue( (yylsp[-1]).first_line, (yylsp[-1]).first_column ); }
#line 2466 "chuck.tab.c"
    break;

  case 72: /* selection_statement: IF LPAREN expression RPAREN statement  */
#line 369 "chuck.y"
            { (yyval.stmt) = new_stmt_from_if( (yyvsp[-2].exp), (yyvsp[0].stmt), NULL, (yylsp[-4]).first_line, (yylsp[-4]).first_column ); }
#line 2472 "chuck.tab.c"
    break;

  case 73: /* selection_statement: IF LPAREN expression RPAREN statement ELSE statement  */
#line 371 "chuck.y"
            { (yyval.stmt) = new_stmt_from_if( (yyvsp[-4].exp), (yyvsp[-2].stmt), (yyvsp[0].stmt), (yylsp[-6]).first_line, (yylsp[-6]).first_column ); }
#line 2478 "chuck.tab.c"
    break;

  case 74: /* loop_statement: WHILE LPAREN expression RPAREN statement  */
#line 376 "chuck.y"
            { (yyval.stmt) = new_stmt_from_while( (yyvsp[-2].exp), (yyvsp[0].stmt), (yylsp[-4]).first_line, (yylsp[-4]).first_column ); }
#line 2484 "chuck.tab.c"
    break;

  case 75: /* loop_statement: DO statement WHILE LPAREN expression RPAREN SEMICOLON  */
#line 378 "chuck.y"
            { (yyval.stmt) = new_stmt_from_do_while( (yyvsp[-2].exp), (yyvsp[-5].stmt), (yylsp[-6]).first_line, (yylsp[-6]).first_column ); }
#line 2490 "chuck.tab.c"
    break;

  case 76: /* loop_statement: FOR LPAREN expression_statement expression_statement RPAREN statement  */
#line 380 "chuck.y"
            { (yyval.stmt) = new_stmt_from_for( (yyvsp[-3].stmt), (yyvsp[-2].stmt), NULL, (yyvsp[0].stmt), (yylsp[-5]).first_line, (yylsp[-5]).first_column ); }
#line 2496 "chuck.tab.c"
    break;

  case 77: /* loop_statement: FOR LPAREN expression_statement expression_statement expression RPAREN statement  */
#line 382 "chuck.y"
            { (yyval.stmt) = new_stmt_from_for( (yyvsp[-4].stmt), (yyvsp[-3].stmt), (yyvsp[-2].exp), (yyvsp[0].stmt), (yylsp[-6]).first_line, (yylsp[-6]).first_column ); }
#line 2502 "chuck.tab.c"
    break;

  case 78: /* loop_statement: FOR LPAREN expression COLON expression RPAREN statement  */
#line 384 "chuck.y"
            { (yyval.stmt) = new_stmt_from_foreach( (yyvsp[-4].exp), (yyvsp[-2].exp), (yyvsp[0].stmt), (yylsp[-6]).first_line, (yylsp[-6]).first_column ); }
#line 2508 "chuck.tab.c"
    break;

  case 79: /* loop_statement: UNTIL LPAREN expression RPAREN statement  */
#line 386 "chuck.y"
            { (yyval.stmt) = new_stmt_from_until( (yyvsp[-2].exp), (yyvsp[0].stmt), (yylsp[-4]).first_line, (yylsp[-4]).first_column ); }
#line 2514 "chuck.tab.c"
    break;

  case 80: /* loop_statement: DO statement UNTIL LPAREN expression RPAREN SEMICOLON  */
#line 388 "chuck.y"
            { (yyval.stmt) = new_stmt_from_do_until( (yyvsp[-2].exp), (yyvsp[-5].stmt), (yylsp[-6]).first_line, (yylsp[-6]).first_column ); }
#line 2520 "chuck.tab.c"
    break;

  case 81: /* loop_statement: LOOP LPAREN expression RPAREN statement  */
#line 390 "chuck.y"
            { (yyval.stmt) = new_stmt_from_loop( (yyvsp[-2].exp), (yyvsp[0].stmt), (yylsp[-4]).first_line, (yylsp[-4]).first_column ); }
#line 2526 "chuck.tab.c"
    break;

  case 82: /* code_segment: LBRACE RBRACE  */
#line 394 "chuck.y"
                                            { (yyval.stmt) = new_stmt_from_code( NULL, (yylsp[-1]).first_line, (yylsp[-1]).first_column ); }
#line 2532 "chuck.tab.c"
    break;

  case 83: /* code_segment: LBRACE statement_list RBRACE  */
#line 395 "chuck.y"
                                            { (yyval.stmt) = new_stmt_from_code( (yyvsp[-1].stmt_list), (yylsp[-2]).first_line, (yylsp[-2]).first_column ); }
#line 2538 "chuck.tab.c"
    break;

  case 84: /* expression_statement: SEMICOLON  */
#line 399 "chuck.y"
                                            { (yyval.stmt) = NULL; }
#line 2544 "chuck.tab.c"
    break;

  case 85: /* expression_statement: expression SEMICOLON  */
#line 400 "chuck.y"
                                            { (yyval.stmt) = new_stmt_from_expression( (yyvsp[-1].exp), (yylsp[-1]).first_line, (yylsp[-1]).first_column ); }
#line 2550 "chuck.tab.c"
    break;

  case 86: /* expression: chuck_expression  */
#line 404 "chuck.y"
                                            { (yyval.exp) = (yyvsp[0].exp); }
#line 2556 "chuck.tab.c"
    break;

  case 87: /* expression: expression COMMA chuck_expression  */
#line 405 "chuck.y"
                                             { (yyval.exp) = append_expression( (yyvsp[-2].exp), (yyvsp[0].exp), (yylsp[-2]).first_line, (yylsp[-2]).first_column ); }
#line 2562 "chuck.tab.c"
    break;

  case 88: /* chuck_expression: arrow_expression  */
#line 409 "chuck.y"
                                             { (yyval.exp) = (yyvsp[0].exp); }
#line 2568 "chuck.tab.c"
    break;

  case 89: /* chuck_expression: chuck_expression chuck_operator arrow_expression  */
#line 411 "chuck.y"
            { (yyval.exp) = new_exp_from_binary( (yyvsp[-2].exp), (yyvsp[-1].ival), (yyvsp[0].exp), (yylsp[-1]).first_line, (yylsp[-1]).first_column ); }
#line 2574 "chuck.tab.c"
    break;

  case 90: /* arrow_expression: decl_expression  */
#line 415 "chuck.y"
                                            { (yyval.exp) = (yyvsp[0].exp); }
#line 2580 "chuck.tab.c"
    break;

  case 91: /* arrow_expression: arrow_expression arrow_operator decl_expression  */
#line 417 "chuck.y"
            { (yyval.exp) = new_exp_from_binary( (yyvsp[-2].exp), (yyvsp[-1].ival), (yyvsp[0].exp), (yylsp[-1]).first_line, (yylsp[-1]).first_column ); }
#line 2586 "chuck.tab.c"
    break;

  case 92: /* array_exp: LBRACK expression RBRACK  */
#line 421 "chuck.y"
                                            { (yyval.array_sub) = new_array_sub( (yyvsp[-1].exp), (yylsp[-2]).first_line, (yylsp[-2]).first_column ); }
#line 2592 "chuck.tab.c"
    break;

  case 93: /* array_exp: LBRACK expression COMMA RBRACK  */
#line 422 "chuck.y"
                                            { (yyval.array_sub) = new_array_sub( (yyvsp[-2].exp), (yylsp[-3]).first_line, (yylsp[-3]).first_column ); }
#line 2598 "chuck.tab.c"
    break;

  case 94: /* array_exp: LBRACK expression RBRACK array_exp  */
#line 424 "chuck.y"
            { (yyval.array_sub) = prepend_array_sub( (yyvsp[0].array_sub), (yyvsp[-2].exp), (yylsp[-3]).first_line, (yylsp[-3]).first_column ); }
#line 2604 "chuck.tab.c"
    break;

  case 95: /* array_exp: LBRACK expression COMMA RBRACK array_exp  */
#line 426 "chuck.y"
            { (yyval.array_sub) = prepend_array_sub( (yyvsp[0].array_sub), (yyvsp[-3].exp), (yylsp[-4]).first_line, (yylsp[-4]).first_column ); }
#line 2610 "chuck.tab.c"
    break;

  case 96: /* array_empty: LBRACK RBRACK  */
#line 430 "chuck.y"
                                            { (yyval.array_sub) = new_array_sub( NULL, (yylsp[-1]).first_line, (yylsp[-1]).first_column ); }
#line 2616 "chuck.tab.c"
    break;

  case 97: /* array_empty: array_empty LBRACK RBRACK  */
#line 431 "chuck.y"
                                            { (yyval.array_sub) = prepend_array_sub( (yyvsp[-2].array_sub), NULL, (yylsp[-2]).first_line, (yylsp[-2]).first_column ); }
#line 2622 "chuck.tab.c"
    break;

  case 98: /* decl_expression: conditional_expression  */
#line 435 "chuck.y"
                                            { (yyval.exp) = (yyvsp[0].exp); }
#line 2628 "chuck.tab.c"
    break;

  case 99: /* decl_expression: type_decl var_decl_list  */
#line 436 "chuck.y"
                                            { (yyval.exp) = new_exp_decl( (yyvsp[-1].type_decl), (yyvsp[0].var_decl_list), 0, 0, (yylsp[-1]).first_line, (yylsp[-1]).first_column ); }
#line 2634 "chuck.tab.c"
    break;

  case 100: /* decl_expression: EXTERNAL type_decl var_decl_list  */
#line 437 "chuck.y"
                                            { (yyval.exp) = new_exp_decl_external( (yyvsp[-1].type_decl), (yyvsp[0].var_decl_list), 0, 0, (yylsp[-2]).first_line, (yylsp[-2]).first_column ); }
#line 2640 "chuck.tab.c"
    break;

  case 101: /* decl_expression: GLOBAL type_decl var_decl_list  */
#line 438 "chuck.y"
                                            { (yyval.exp) = new_exp_decl_global( (yyvsp[-1].type_decl), (yyvsp[0].var_decl_list), 0, 0, (yylsp[-2]).first_line, (yylsp[-2]).first_column ); }
#line 2646 "chuck.tab.c"
    break;

  case 102: /* decl_expression: STATIC type_decl var_decl_list  */
#line 439 "chuck.y"
                                            { (yyval.exp) = new_exp_decl( (yyvsp[-1].type_decl), (yyvsp[0].var_decl_list), 1, 0, (yylsp[-2]).first_line, (yylsp[-2]).first_column ); }
#line 2652 "chuck.tab.c"
    break;

  case 103: /* decl_expression: SAME var_decl_list  */
#line 440 "chuck.y"
                                            { (yyval.exp) = new_exp_decl( NULL, (yyvsp[0].var_decl_list), 0, 0, (yylsp[-1]).first_line, (yylsp[-1]).first_column ); }
#line 2658 "chuck.tab.c"
    break;

  case 104: /* decl_expression: STATIC SAME var_decl_list  */
#line 441 "chuck.y"
                                            { (yyval.exp) = new_exp_decl( NULL, (yyvsp[0].var_decl_list), 1, 0, (yylsp[-2]).first_line, (yylsp[-2]).first_column ); }
#line 2664 "chuck.tab.c"
    break;

  case 105: /* var_decl_list: var_decl  */
#line 445 "chuck.y"
                                            { (yyval.var_decl_list) = new_var_decl_list( (yyvsp[0].var_decl), (yylsp[0]).first_line, (yylsp[0]).first_column ); }
#line 2670 "chuck.tab.c"
    break;

  case 106: /* var_decl_list: var_decl COMMA var_decl_list  */
#line 446 "chuck.y"
                                            { (yyval.var_decl_list) = prepend_var_decl_list( (yyvsp[-2].var_decl), (yyvsp[0].var_decl_list), (yylsp[-2]).first_line, (yylsp[-2]).first_column ); }
#line 2676 "chuck.tab.c"
    break;

  case 107: /* var_decl: ID  */
#line 450 "chuck.y"
                                            { (yyval.var_decl) = new_var_decl( (yyvsp[0].sval), FALSE, NULL, NULL, (yylsp[0]).first_line, (yylsp[0]).first_column ); }
#line 2682 "chuck.tab.c"
    break;

  case 108: /* var_decl: ID array_exp  */
#line 451 "chuck.y"
                                            { (yyval.var_decl) = new_var_decl( (yyvsp[-1].sval), FALSE, NULL, (yyvsp[0].array_sub), (yylsp[-1]).first_line, (yylsp[-1]).first_column ); }
#line 2688 "chuck.tab.c"
    break;

  case 109: /* var_decl: ID array_empty  */
#line 452 "chuck.y"
                                            { (yyval.var_decl) = new_var_decl( (yyvsp[-1].sval), FALSE, NULL, (yyvsp[0].array_sub), (yylsp[-1]).first_line, (yylsp[-1]).first_column ); }
#line 2694 "chuck.tab.c"
    break;

  case 110: /* var_decl: ID LPAREN RPAREN  */
#line 453 "chuck.y"
                                            { (yyval.var_decl) = new_var_decl( (yyvsp[-2].sval), TRUE, NULL, NULL, (yylsp[-2]).first_line, (yylsp[-2]).first_column ); }
#line 2700 "chuck.tab.c"
    break;

  case 111: /* var_decl: ID LPAREN expression RPAREN  */
#line 454 "chuck.y"
                                            { (yyval.var_decl) = new_var_decl( (yyvsp[-3].sval), TRUE, (yyvsp[-1].exp), NULL, (yylsp[-3]).first_line, (yylsp[-3]).first_column ); }
#line 2706 "chuck.tab.c"
    break;

  case 112: /* var_decl: ID LPAREN RPAREN array_exp  */
#line 455 "chuck.y"
                                            { (yyval.var_decl) = new_var_decl( (yyvsp[-3].sval), TRUE, NULL, (yyvsp[0].array_sub), (yylsp[-3]).first_line, (yylsp[-3]).first_column ); }
#line 2712 "chuck.tab.c"
    break;

  case 113: /* var_decl: ID LPAREN expression RPAREN array_exp  */
#line 456 "chuck.y"
                                                 { (yyval.var_decl) = new_var_decl( (yyvsp[-4].sval), TRUE, (yyvsp[-2].exp), (yyvsp[0].array_sub), (yylsp[-4]).first_line, (yylsp[-4]).first_column ); }
#line 2718 "chuck.tab.c"
    break;

  case 114: /* complex_exp: POUNDPAREN expression RPAREN  */
#line 461 "chuck.y"
            { (yyval.complex_exp) = new_complex( (yyvsp[-1].exp), (yylsp[-2]).first_line, (yylsp[-2]).first_column ); }
#line 2724 "chuck.tab.c"
    break;

  case 115: /* polar_exp: PERCENTPAREN expression RPAREN  */
#line 466 "chuck.y"
            { (yyval.polar_exp) = new_polar( (yyvsp[-1].exp), (yylsp[-2]).first_line, (yylsp[-2]).first_column ); }
#line 2730 "chuck.tab.c"
    break;

  case 116: /* vec_exp: ATPAREN expression RPAREN  */
#line 471 "chuck.y"
            { (yyval.vec_exp) = new_vec( (yyvsp[-1].exp), (yylsp[-2]).first_line, (yylsp[-2]).first_column ); }
#line 2736 "chuck.tab.c"
    break;

  case 117: /* chuck_operator: CHUCK  */
#line 475 "chuck.y"
                                            { (yyval.ival) = ae_op_chuck; }
#line 2742 "chuck.tab.c"
    break;

  case 118: /* chuck_operator: AT_CHUCK  */
#line 476 "chuck.y"
                                            { (yyval.ival) = ae_op_at_chuck; }
#line 2748 "chuck.tab.c"
    break;

  case 119: /* chuck_operator: PLUS_CHUCK  */
#line 477 "chuck.y"
                                            { (yyval.ival) = ae_op_plus_chuck; }
#line 2754 "chuck.tab.c"
    break;

  case 120: /* chuck_operator: MINUS_CHUCK  */
#line 478 "chuck.y"
                                            { (yyval.ival) = ae_op_minus_chuck; }
#line 2760 "chuck.tab.c"
    break;

  case 121: /* chuck_operator: TIMES_CHUCK  */
#line 479 "chuck.y"
                                            { (yyval.ival) = ae_op_times_chuck; }
#line 2766 "chuck.tab.c"
    break;

  case 122: /* chuck_operator: DIVIDE_CHUCK  */
#line 480 "chuck.y"
                                            { (yyval.ival) = ae_op_divide_chuck; }
#line 2772 "chuck.tab.c"
    break;

  case 123: /* chuck_operator: SHIFT_RIGHT_CHUCK  */
#line 481 "chuck.y"
                                            { (yyval.ival) = ae_op_shift_right_chuck; }
#line 2778 "chuck.tab.c"
    break;

  case 124: /* chuck_operator: SHIFT_LEFT_CHUCK  */
#line 482 "chuck.y"
                                            { (yyval.ival) = ae_op_shift_left_chuck; }
#line 2784 "chuck.tab.c"
    break;

  case 125: /* chuck_operator: PERCENT_CHUCK  */
#line 483 "chuck.y"
                                            { (yyval.ival) = ae_op_percent_chuck; }
#line 2790 "chuck.tab.c"
    break;

  case 126: /* chuck_operator: UNCHUCK  */
#line 484 "chuck.y"
                                            { (yyval.ival) = ae_op_unchuck; }
#line 2796 "chuck.tab.c"
    break;

  case 127: /* chuck_operator: UPCHUCK  */
#line 485 "chuck.y"
                                            { (yyval.ival) = ae_op_upchuck; }
#line 2802 "chuck.tab.c"
    break;

  case 128: /* chuck_operator: S_AND_CHUCK  */
#line 486 "chuck.y"
                                            { (yyval.ival) = ae_op_s_and_chuck; }
#line 2808 "chuck.tab.c"
    break;

  case 129: /* chuck_operator: S_OR_CHUCK  */
#line 487 "chuck.y"
                                            { (yyval.ival) = ae_op_s_or_chuck; }
#line 2814 "chuck.tab.c"
    break;

  case 130: /* chuck_operator: S_XOR_CHUCK  */
#line 488 "chuck.y"
                                            { (yyval.ival) = ae_op_s_xor_chuck; }
#line 2820 "chuck.tab.c"
    break;

  case 131: /* arrow_operator: ARROW_LEFT  */
#line 492 "chuck.y"
                                            { (yyval.ival) = ae_op_arrow_left; }
#line 2826 "chuck.tab.c"
    break;

  case 132: /* arrow_operator: ARROW_RIGHT  */
#line 493 "chuck.y"
                                            { (yyval.ival) = ae_op_arrow_right; }
#line 2832 "chuck.tab.c"
    break;

  case 133: /* arrow_operator: GRUCK_LEFT  */
#line 494 "chuck.y"
                                            { (yyval.ival) = ae_op_gruck_left; }
#line 2838 "chuck.tab.c"
    break;

  case 134: /* arrow_operator: GRUCK_RIGHT  */
#line 495 "chuck.y"
                                            { (yyval.ival) = ae_op_gruck_right; }
#line 2844 "chuck.tab.c"
    break;

  case 135: /* arrow_operator: UNGRUCK_LEFT  */
#line 496 "chuck.y"
                                            { (yyval.ival) = ae_op_ungruck_left; }
#line 2850 "chuck.tab.c"
    break;

  case 136: /* arrow_operator: UNGRUCK_RIGHT  */
#line 497 "chuck.y"
                                            { (yyval.ival) = ae_op_ungruck_right; }
#line 2856 "chuck.tab.c"
    break;

  case 137: /* conditional_expression: logical_or_expression  */
#line 501 "chuck.y"
                                            { (yyval.exp) = (yyvsp[0].exp); }
#line 2862 "chuck.tab.c"
    break;

  case 138: /* conditional_expression: logical_or_expression QUESTION expression COLON conditional_expression  */
#line 503 "chuck.y"
            { (yyval.exp) = new_exp_from_if( (yyvsp[-4].exp), (yyvsp[-2].exp), (yyvsp[0].exp), (yylsp[-4]).first_line, (yylsp[-4]).first_column ); }
#line 2868 "chuck.tab.c"
    break;

  case 139: /* logical_or_expression: logical_and_expression  */
#line 507 "chuck.y"
                                            { (yyval.exp) = (yyvsp[0].exp); }
#line 2874 "chuck.tab.c"
    break;

  case 140: /* logical_or_expression: logical_or_expression OR logical_and_expression  */
#line 509 "chuck.y"
            { (yyval.exp) = new_exp_from_binary( (yyvsp[-2].exp), ae_op_or, (yyvsp[0].exp), (yylsp[-1]).first_line, (yylsp[-1]).first_column ); }
#line 2880 "chuck.tab.c"
    break;

  case 141: /* logical_and_expression: inclusive_or_expression  */
#line 513 "chuck.y"
                                            { (yyval.exp) = (yyvsp[0].exp); }
#line 2886 "chuck.tab.c"
    break;

  case 142: /* logical_and_expression: logical_and_expression AND inclusive_or_expression  */
#line 515 "chuck.y"
            { (yyval.exp) = new_exp_from_binary( (yyvsp[-2].exp), ae_op_and, (yyvsp[0].exp), (yylsp[-1]).first_line, (yylsp[-1]).first_column ); }
#line 2892 "chuck.tab.c"
    break;

  case 143: /* inclusive_or_expression: exclusive_or_expression  */
#line 519 "chuck.y"
                                            { (yyval.exp) = (yyvsp[0].exp); }
#line 2898 "chuck.tab.c"
    break;

  case 144: /* inclusive_or_expression: inclusive_or_expression S_OR exclusive_or_expression  */
#line 521 "chuck.y"
            { (yyval.exp) = new_exp_from_binary( (yyvsp[-2].exp), ae_op_s_or, (yyvsp[0].exp), (yylsp[-1]).first_line, (yylsp[-1]).first_column ); }
#line 2904 "chuck.tab.c"
    break;

  case 145: /* exclusive_or_expression: and_expression  */
#line 525 "chuck.y"
                                            { (yyval.exp) = (yyvsp[0].exp); }
#line 2910 "chuck.tab.c"
    break;

  case 146: /* exclusive_or_expression: exclusive_or_expression S_XOR and_expression  */
#line 527 "chuck.y"
            { (yyval.exp) = new_exp_from_binary( (yyvsp[-2].exp), ae_op_s_xor, (yyvsp[0].exp), (yylsp[-1]).first_line, (yylsp[-1]).first_column ); }
#line 2916 "chuck.tab.c"
    break;

  case 147: /* and_expression: equality_expression  */
#line 531 "chuck.y"
                                            { (yyval.exp) = (yyvsp[0].exp); }
#line 2922 "chuck.tab.c"
    break;

  case 148: /* and_expression: and_expression S_AND equality_expression  */
#line 533 "chuck.y"
            { (yyval.exp) = new_exp_from_binary( (yyvsp[-2].exp), ae_op_s_and, (yyvsp[0].exp), (yylsp[-1]).first_line, (yylsp[-1]).first_column ); }
#line 2928 "chuck.tab.c"
    break;

  case 149: /* equality_expression: relational_expression  */
#line 537 "chuck.y"
                                            { (yyval.exp) = (yyvsp[0].exp); }
#line 2934 "chuck.tab.c"
    break;

  case 150: /* equality_expression: equality_expression EQ relational_expression  */
#line 539 "chuck.y"
            { (yyval.exp) = new_exp_from_binary( (yyvsp[-2].exp), ae_op_eq, (yyvsp[0].exp), (yylsp[-2]).first_line, (yylsp[-2]).first_column ); }
#line 2940 "chuck.tab.c"
    break;

  case 151: /* equality_expression: equality_expression NEQ relational_expression  */
#line 541 "chuck.y"
            { (yyval.exp) = new_exp_from_binary( (yyvsp[-2].exp), ae_op_neq, (yyvsp[0].exp), (yylsp[-1]).first_line, (yylsp[-1]).first_column ); }
#line 2946 "chuck.tab.c"
    break;

  case 152: /* relational_expression: shift_expression  */
#line 545 "chuck.y"
                                            { (yyval.exp) = (yyvsp[0].exp); }
#line 2952 "chuck.tab.c"
    break;

  case 153: /* relational_expression: relational_expression LT shift_expression  */
#line 547 "chuck.y"
            { (yyval.exp) = new_exp_from_binary( (yyvsp[-2].exp), ae_op_lt, (yyvsp[0].exp), (yylsp[-1]).first_line, (yylsp[-1]).first_column ); }
#line 2958 "chuck.tab.c"
    break;

  case 154: /* relational_expression: relational_expression GT shift_expression  */
#line 549 "chuck.y"
            { (yyval.exp) = new_exp_from_binary( (yyvsp[-2].exp), ae_op_gt, (yyvsp[0].exp), (yylsp[-1]).first_line, (yylsp[-1]).first_column ); }
#line 2964 "chuck.tab.c"
    break;

  case 155: /* relational_expression: relational_expression LE shift_expression  */
#line 551 "chuck.y"
            { (yyval.exp) = new_exp_from_binary( (yyvsp[-2].exp), ae_op_le, (yyvsp[0].exp), (yylsp[-1]).first_line, (yylsp[-1]).first_column ); }
#line 2970 "chuck.tab.c"
    break;

  case 156: /* relational_expression: relational_expression GE shift_expression  */
#line 553 "chuck.y"
            { (yyval.exp) = new_exp_from_binary( (yyvsp[-2].exp), ae_op_ge, (yyvsp[0].exp), (yylsp[-1]).first_line, (yylsp[-1]).first_column ); }
#line 2976 "chuck.tab.c"
    break;

  case 157: /* shift_expression: additive_expression  */
#line 557 "chuck.y"
                                            { (yyval.exp) = (yyvsp[0].exp); }
#line 2982 "chuck.tab.c"
    break;

  case 158: /* shift_expression: shift_expression SHIFT_LEFT additive_expression  */
#line 559 "chuck.y"
            { (yyval.exp) = new_exp_from_binary( (yyvsp[-2].exp), ae_op_shift_left, (yyvsp[0].exp), (yylsp[-1]).first_line, (yylsp[-1]).first_column ); }
#line 2988 "chuck.tab.c"
    break;

  case 159: /* shift_expression: shift_expression SHIFT_RIGHT additive_expression  */
#line 561 "chuck.y"
            { (yyval.exp) = new_exp_from_binary( (yyvsp[-2].exp), ae_op_shift_right, (yyvsp[0].exp), (yylsp[-1]).first_line, (yylsp[-1]).first_column ); }
#line 2994 "chuck.tab.c"
    break;

  case 160: /* additive_expression: multiplicative_expression  */
#line 565 "chuck.y"
                                             { (yyval.exp) = (yyvsp[0].exp); }
#line 3000 "chuck.tab.c"
    break;

  case 161: /* additive_expression: additive_expression PLUS multiplicative_expression  */
#line 567 "chuck.y"
            { (yyval.exp) = new_exp_from_binary( (yyvsp[-2].exp), ae_op_plus, (yyvsp[0].exp), (yylsp[-1]).first_line, (yylsp[-1]).first_column ); }
#line 3006 "chuck.tab.c"
    break;

  case 162: /* additive_expression: additive_expression MINUS multiplicative_expression  */
#line 569 "chuck.y"
            { (yyval.exp) = new_exp_from_binary( (yyvsp[-2].exp), ae_op_minus, (yyvsp[0].exp), (yylsp[-1]).first_line, (yylsp[-1]).first_column ); }
#line 3012 "chuck.tab.c"
    break;

  case 163: /* multiplicative_expression: tilda_expression  */
#line 573 "chuck.y"
                                             { (yyval.exp) = (yyvsp[0].exp); }
#line 3018 "chuck.tab.c"
    break;

  case 164: /* multiplicative_expression: multiplicative_expression TIMES tilda_expression  */
#line 575 "chuck.y"
            { (yyval.exp) = new_exp_from_binary( (yyvsp[-2].exp), ae_op_times, (yyvsp[0].exp), (yylsp[-1]).first_line, (yylsp[-1]).first_column ); }
#line 3024 "chuck.tab.c"
    break;

  case 165: /* multiplicative_expression: multiplicative_expression DIVIDE tilda_expression  */
#line 577 "chuck.y"
            { (yyval.exp) = new_exp_from_binary( (yyvsp[-2].exp), ae_op_divide, (yyvsp[0].exp), (yylsp[-1]).first_line, (yylsp[-1]).first_column ); }
#line 3030 "chuck.tab.c"
    break;

  case 166: /* multiplicative_expression: multiplicative_expression PERCENT tilda_expression  */
#line 579 "chuck.y"
            { (yyval.exp) = new_exp_from_binary( (yyvsp[-2].exp), ae_op_percent, (yyvsp[0].exp), (yylsp[-1]).first_line, (yylsp[-1]).first_column ); }
#line 3036 "chuck.tab.c"
    break;

  case 167: /* tilda_expression: cast_expression  */
#line 583 "chuck.y"
                                            { (yyval.exp) = (yyvsp[0].exp); }
#line 3042 "chuck.tab.c"
    break;

  case 168: /* tilda_expression: tilda_expression TILDA cast_expression  */
#line 585 "chuck.y"
            { (yyval.exp) = new_exp_from_binary( (yyvsp[-2].exp), ae_op_tilda, (yyvsp[0].exp), (yylsp[-1]).first_line, (yylsp[-1]).first_column ); }
#line 3048 "chuck.tab.c"
    break;

  case 169: /* cast_expression: unary_expression  */
#line 589 "chuck.y"
                                            { (yyval.exp) = (yyvsp[0].exp); }
#line 3054 "chuck.tab.c"
    break;

  case 170: /* cast_expression: cast_expression DOLLAR type_decl  */
#line 591 "chuck.y"
            { (yyval.exp) = new_exp_from_cast( (yyvsp[0].type_decl), (yyvsp[-2].exp), (yylsp[-2]).first_line, (yylsp[-2]).first_column, (yylsp[-1]).first_column ); }
#line 3060 "chuck.tab.c"
    break;

  case 171: /* unary_expression: dur_expression  */
#line 595 "chuck.y"
                                            { (yyval.exp) = (yyvsp[0].exp); }
#line 3066 "chuck.tab.c"
    break;

  case 172: /* unary_expression: PLUSPLUS unary_expression  */
#line 597 "chuck.y"
            { (yyval.exp) = new_exp_from_unary( ae_op_plusplus, (yyvsp[0].exp), (yylsp[-1]).first_line, (yylsp[-1]).first_column ); }
#line 3072 "chuck.tab.c"
    break;

  case 173: /* unary_expression: MINUSMINUS unary_expression  */
#line 599 "chuck.y"
            { (yyval.exp) = new_exp_from_unary( ae_op_minusminus, (yyvsp[0].exp), (yylsp[-1]).first_line, (yylsp[-1]).first_column ); }
#line 3078 "chuck.tab.c"
    break;

  case 174: /* unary_expression: unary_operator unary_expression  */
#line 601 "chuck.y"
            { (yyval.exp) = new_exp_from_unary( (yyvsp[-1].ival), (yyvsp[0].exp), (yylsp[-1]).first_line, (yylsp[-1]).first_column ); }
#line 3084 "chuck.tab.c"
    break;

  case 175: /* unary_expression: TYPEOF unary_expression  */
#line 603 "chuck.y"
            { (yyval.exp) = new_exp_from_unary( ae_op_typeof, (yyvsp[0].exp), (yylsp[-1]).first_line, (yylsp[-1]).first_column ); }
#line 3090 "chuck.tab.c"
    break;

  case 176: /* unary_expression: SIZEOF unary_expression  */
#line 605 "chuck.y"
            { (yyval.exp) = new_exp_from_unary( ae_op_sizeof, (yyvsp[0].exp), (yylsp[-1]).first_line, (yylsp[-1]).first_column ); }
#line 3096 "chuck.tab.c"
    break;

  case 177: /* unary_expression: NEW type_decl  */
#line 607 "chuck.y"
            { (yyval.exp) = new_exp_from_unary2( ae_op_new, (yyvsp[0].type_decl), FALSE, NULL, NULL, (yylsp[-1]).first_line, (yylsp[-1]).first_column ); }
#line 3102 "chuck.tab.c"
    break;

  case 178: /* unary_expression: NEW type_decl array_exp  */
#line 609 "chuck.y"
            { (yyval.exp) = new_exp_from_unary2( ae_op_new, (yyvsp[-1].type_decl), FALSE, NULL, (yyvsp[0].array_sub), (yylsp[-2]).first_line, (yylsp[-2]).first_column ); }
#line 3108 "chuck.tab.c"
    break;

  case 179: /* unary_expression: NEW type_decl LPAREN RPAREN  */
#line 611 "chuck.y"
            { (yyval.exp) = new_exp_from_unary2( ae_op_new, (yyvsp[-2].type_decl), TRUE, NULL, NULL, (yylsp[-3]).first_line, (yylsp[-3]).first_column ); }
#line 3114 "chuck.tab.c"
    break;

  case 180: /* unary_expression: NEW type_decl LPAREN expression RPAREN  */
#line 613 "chuck.y"
            { (yyval.exp) = new_exp_from_unary2( ae_op_new, (yyvsp[-3].type_decl), TRUE, (yyvsp[-1].exp), NULL, (yylsp[-4]).first_line, (yylsp[-4]).first_column ); }
#line 3120 "chuck.tab.c"
    break;

  case 181: /* unary_expression: NEW type_decl LPAREN RPAREN array_exp  */
#line 615 "chuck.y"
            { (yyval.exp) = new_exp_from_unary2( ae_op_new, (yyvsp[-3].type_decl), TRUE, NULL, (yyvsp[0].array_sub), (yylsp[-4]).first_line, (yylsp[-4]).first_column ); }
#line 3126 "chuck.tab.c"
    break;

  case 182: /* unary_expression: NEW type_decl LPAREN expression RPAREN array_exp  */
#line 617 "chuck.y"
            { (yyval.exp) = new_exp_from_unary2( ae_op_new, (yyvsp[-4].type_decl), TRUE, (yyvsp[-2].exp), (yyvsp[0].array_sub), (yylsp[-5]).first_line, (yylsp[-5]).first_column ); }
#line 3132 "chuck.tab.c"
    break;

  case 183: /* unary_operator: PLUS  */
#line 623 "chuck.y"
                                            { (yyval.ival) = ae_op_plus; }
#line 3138 "chuck.tab.c"
    break;

  case 184: /* unary_operator: MINUS  */
#line 624 "chuck.y"
                                            { (yyval.ival) = ae_op_minus; }
#line 3144 "chuck.tab.c"
    break;

  case 185: /* unary_operator: TILDA  */
#line 625 "chuck.y"
                                            { (yyval.ival) = ae_op_tilda; }
#line 3150 "chuck.tab.c"
    break;

  case 186: /* unary_operator: EXCLAMATION  */
#line 626 "chuck.y"
                                            { (yyval.ival) = ae_op_exclamation; }
#line 3156 "chuck.tab.c"
    break;

  case 187: /* unary_operator: TIMES  */
#line 627 "chuck.y"
                                            { (yyval.ival) = ae_op_times; }
#line 3162 "chuck.tab.c"
    break;

  case 188: /* unary_operator: SPORK TILDA  */
#line 628 "chuck.y"
                                            { (yyval.ival) = ae_op_spork; }
#line 3168 "chuck.tab.c"
    break;

  case 189: /* overloadable_operator: CHUCK  */
#line 634 "chuck.y"
                                            { (yyval.ival) = ae_op_chuck; }
#line 3174 "chuck.tab.c"
    break;

  case 190: /* overloadable_operator: PLUS  */
#line 635 "chuck.y"
                                            { (yyval.ival) = ae_op_plus; }
#line 3180 "chuck.tab.c"
    break;

  case 191: /* overloadable_operator: MINUS  */
#line 636 "chuck.y"
                                            { (yyval.ival) = ae_op_minus; }
#line 3186 "chuck.tab.c"
    break;

  case 192: /* overloadable_operator: TIMES  */
#line 637 "chuck.y"
                                            { (yyval.ival) = ae_op_times; }
#line 3192 "chuck.tab.c"
    break;

  case 193: /* overloadable_operator: DIVIDE  */
#line 638 "chuck.y"
                                            { (yyval.ival) = ae_op_divide; }
#line 3198 "chuck.tab.c"
    break;

  case 194: /* overloadable_operator: PERCENT  */
#line 639 "chuck.y"
                                            { (yyval.ival) = ae_op_percent; }
#line 3204 "chuck.tab.c"
    break;

  case 195: /* overloadable_operator: EQ  */
#line 640 "chuck.y"
                                            { (yyval.ival) = ae_op_eq; }
#line 3210 "chuck.tab.c"
    break;

  case 196: /* overloadable_operator: NEQ  */
#line 641 "chuck.y"
                                            { (yyval.ival) = ae_op_neq; }
#line 3216 "chuck.tab.c"
    break;

  case 197: /* overloadable_operator: LT  */
#line 642 "chuck.y"
                                            { (yyval.ival) = ae_op_lt; }
#line 3222 "chuck.tab.c"
    break;

  case 198: /* overloadable_operator: LE  */
#line 643 "chuck.y"
                                            { (yyval.ival) = ae_op_le; }
#line 3228 "chuck.tab.c"
    break;

  case 199: /* overloadable_operator: GT  */
#line 644 "chuck.y"
                                            { (yyval.ival) = ae_op_gt; }
#line 3234 "chuck.tab.c"
    break;

  case 200: /* overloadable_operator: GE  */
#line 645 "chuck.y"
                                            { (yyval.ival) = ae_op_ge; }
#line 3240 "chuck.tab.c"
    break;

  case 201: /* overloadable_operator: AND  */
#line 646 "chuck.y"
                                            { (yyval.ival) = ae_op_and; }
#line 3246 "chuck.tab.c"
    break;

  case 202: /* overloadable_operator: OR  */
#line 647 "chuck.y"
                                            { (yyval.ival) = ae_op_or; }
#line 3252 "chuck.tab.c"
    break;

  case 203: /* overloadable_operator: ASSIGN  */
#line 648 "chuck.y"
                                            { (yyval.ival) = ae_op_assign; }
#line 3258 "chuck.tab.c"
    break;

  case 204: /* overloadable_operator: EXCLAMATION  */
#line 649 "chuck.y"
                                            { (yyval.ival) = ae_op_exclamation; }
#line 3264 "chuck.tab.c"
    break;

  case 205: /* overloadable_operator: S_OR  */
#line 650 "chuck.y"
                                            { (yyval.ival) = ae_op_s_or; }
#line 3270 "chuck.tab.c"
    break;

  case 206: /* overloadable_operator: S_AND  */
#line 651 "chuck.y"
                                            { (yyval.ival) = ae_op_s_and; }
#line 3276 "chuck.tab.c"
    break;

  case 207: /* overloadable_operator: S_XOR  */
#line 652 "chuck.y"
                                            { (yyval.ival) = ae_op_s_xor; }
#line 3282 "chuck.tab.c"
    break;

  case 208: /* overloadable_operator: PLUSPLUS  */
#line 653 "chuck.y"
                                            { (yyval.ival) = ae_op_plusplus; }
#line 3288 "chuck.tab.c"
    break;

  case 209: /* overloadable_operator: MINUSMINUS  */
#line 654 "chuck.y"
                                            { (yyval.ival) = ae_op_minusminus; }
#line 3294 "chuck.tab.c"
    break;

  case 210: /* overloadable_operator: DOLLAR  */
#line 655 "chuck.y"
                                            { (yyval.ival) = ae_op_dollar; }
#line 3300 "chuck.tab.c"
    break;

  case 211: /* overloadable_operator: ATAT_SYM  */
#line 656 "chuck.y"
                                            { (yyval.ival) = ae_op_at_at; }
#line 3306 "chuck.tab.c"
    break;

  case 212: /* overloadable_operator: PLUS_CHUCK  */
#line 657 "chuck.y"
                                            { (yyval.ival) = ae_op_plus_chuck; }
#line 3312 "chuck.tab.c"
    break;

  case 213: /* overloadable_operator: MINUS_CHUCK  */
#line 658 "chuck.y"
                                            { (yyval.ival) = ae_op_minus_chuck; }
#line 3318 "chuck.tab.c"
    break;

  case 214: /* overloadable_operator: TIMES_CHUCK  */
#line 659 "chuck.y"
                                            { (yyval.ival) = ae_op_times_chuck; }
#line 3324 "chuck.tab.c"
    break;

  case 215: /* overloadable_operator: DIVIDE_CHUCK  */
#line 660 "chuck.y"
                                            { (yyval.ival) = ae_op_divide_chuck; }
#line 3330 "chuck.tab.c"
    break;

  case 216: /* overloadable_operator: S_AND_CHUCK  */
#line 661 "chuck.y"
                                            { (yyval.ival) = ae_op_s_and_chuck; }
#line 3336 "chuck.tab.c"
    break;

  case 217: /* overloadable_operator: S_OR_CHUCK  */
#line 662 "chuck.y"
                                            { (yyval.ival) = ae_op_s_or_chuck; }
#line 3342 "chuck.tab.c"
    break;

  case 218: /* overloadable_operator: S_XOR_CHUCK  */
#line 663 "chuck.y"
                                            { (yyval.ival) = ae_op_s_xor_chuck; }
#line 3348 "chuck.tab.c"
    break;

  case 219: /* overloadable_operator: SHIFT_RIGHT_CHUCK  */
#line 664 "chuck.y"
                                            { (yyval.ival) = ae_op_shift_right_chuck; }
#line 3354 "chuck.tab.c"
    break;

  case 220: /* overloadable_operator: SHIFT_LEFT_CHUCK  */
#line 665 "chuck.y"
                                            { (yyval.ival) = ae_op_shift_left_chuck; }
#line 3360 "chuck.tab.c"
    break;

  case 221: /* overloadable_operator: PERCENT_CHUCK  */
#line 666 "chuck.y"
                                            { (yyval.ival) = ae_op_percent_chuck; }
#line 3366 "chuck.tab.c"
    break;

  case 222: /* overloadable_operator: SHIFT_RIGHT  */
#line 667 "chuck.y"
                                            { (yyval.ival) = ae_op_shift_right; }
#line 3372 "chuck.tab.c"
    break;

  case 223: /* overloadable_operator: SHIFT_LEFT  */
#line 668 "chuck.y"
                                            { (yyval.ival) = ae_op_shift_left; }
#line 3378 "chuck.tab.c"
    break;

  case 224: /* overloadable_operator: TILDA  */
#line 669 "chuck.y"
                                            { (yyval.ival) = ae_op_tilda; }
#line 3384 "chuck.tab.c"
    break;

  case 225: /* overloadable_operator: COLONCOLON  */
#line 670 "chuck.y"
                                            { (yyval.ival) = ae_op_coloncolon; }
#line 3390 "chuck.tab.c"
    break;

  case 226: /* overloadable_operator: AT_CHUCK  */
#line 671 "chuck.y"
                                            { (yyval.ival) = ae_op_at_chuck; }
#line 3396 "chuck.tab.c"
    break;

  case 227: /* overloadable_operator: UNCHUCK  */
#line 672 "chuck.y"
                                            { (yyval.ival) = ae_op_unchuck; }
#line 3402 "chuck.tab.c"
    break;

  case 228: /* overloadable_operator: UPCHUCK  */
#line 673 "chuck.y"
                                            { (yyval.ival) = ae_op_upchuck; }
#line 3408 "chuck.tab.c"
    break;

  case 229: /* overloadable_operator: ARROW_RIGHT  */
#line 674 "chuck.y"
                                            { (yyval.ival) = ae_op_arrow_right; }
#line 3414 "chuck.tab.c"
    break;

  case 230: /* overloadable_operator: ARROW_LEFT  */
#line 675 "chuck.y"
                                            { (yyval.ival) = ae_op_arrow_left; }
#line 3420 "chuck.tab.c"
    break;

  case 231: /* overloadable_operator: GRUCK_RIGHT  */
#line 676 "chuck.y"
                                            { (yyval.ival) = ae_op_gruck_right; }
#line 3426 "chuck.tab.c"
    break;

  case 232: /* overloadable_operator: GRUCK_LEFT  */
#line 677 "chuck.y"
                                            { (yyval.ival) = ae_op_gruck_left; }
#line 3432 "chuck.tab.c"
    break;

  case 233: /* overloadable_operator: UNGRUCK_RIGHT  */
#line 678 "chuck.y"
                                            { (yyval.ival) = ae_op_ungruck_right; }
#line 3438 "chuck.tab.c"
    break;

  case 234: /* overloadable_operator: UNGRUCK_LEFT  */
#line 679 "chuck.y"
                                            { (yyval.ival) = ae_op_ungruck_left; }
#line 3444 "chuck.tab.c"
    break;

  case 236: /* dur_expression: dur_expression COLONCOLON postfix_expression  */
#line 685 "chuck.y"
            { (yyval.exp) = new_exp_from_dur( (yyvsp[-2].exp), (yyvsp[0].exp), (yylsp[-2]).first_line, (yylsp[-2]).first_column ); }
#line 3450 "chuck.tab.c"
    break;

  case 237: /* postfix_expression: primary_expression  */
#line 689 "chuck.y"
                                            { (yyval.exp) = (yyvsp[0].exp); }
#line 3456 "chuck.tab.c"
    break;

  case 238: /* postfix_expression: postfix_expression array_exp  */
#line 691 "chuck.y"
            { (yyval.exp) = new_exp_from_array( (yyvsp[-1].exp), (yyvsp[0].array_sub), (yylsp[-1]).first_line, (yylsp[-1]).first_column ); }
#line 3462 "chuck.tab.c"
    break;

  case 239: /* postfix_expression: postfix_expression LPAREN RPAREN  */
#line 693 "chuck.y"
            { (yyval.exp) = new_exp_from_func_call( (yyvsp[-2].exp), NULL, (yylsp[-2]).first_line, (yylsp[-2]).first_column ); }
#line 3468 "chuck.tab.c"
    break;

  case 240: /* postfix_expression: postfix_expression LPAREN expression RPAREN  */
#line 695 "chuck.y"
            { (yyval.exp) = new_exp_from_func_call( (yyvsp[-3].exp), (yyvsp[-1].exp), (yylsp[-3]).first_line, (yylsp[-3]).first_column ); }
#line 3474 "chuck.tab.c"
    break;

  case 241: /* postfix_expression: postfix_expression DOT ID  */
#line 697 "chuck.y"
            { (yyval.exp) = new_exp_from_member_dot( (yyvsp[-2].exp), (yyvsp[0].sval), (yylsp[-2]).first_line, (yylsp[-2]).first_column, (yylsp[0]).first_column ); }
#line 3480 "chuck.tab.c"
    break;

  case 242: /* postfix_expression: postfix_expression PLUSPLUS  */
#line 699 "chuck.y"
            { (yyval.exp) = new_exp_from_postfix( (yyvsp[-1].exp), ae_op_plusplus, (yylsp[-1]).first_line, (yylsp[-1]).first_column ); }
#line 3486 "chuck.tab.c"
    break;

  case 243: /* postfix_expression: postfix_expression MINUSMINUS  */
#line 701 "chuck.y"
            { (yyval.exp) = new_exp_from_postfix( (yyvsp[-1].exp), ae_op_minusminus, (yylsp[-1]).first_line, (yylsp[-1]).first_column ); }
#line 3492 "chuck.tab.c"
    break;

  case 244: /* primary_expression: ID  */
#line 706 "chuck.y"
                                            { (yyval.exp) = new_exp_from_id( (yyvsp[0].sval), (yylsp[0]).first_line, (yylsp[0]).first_column ); }
#line 3498 "chuck.tab.c"
    break;

  case 245: /* primary_expression: INT_VAL  */
#line 707 "chuck.y"
                                            { (yyval.exp) = new_exp_from_int( (yyvsp[0].ival), (yylsp[0]).first_line, (yylsp[0]).first_column ); }
#line 3504 "chuck.tab.c"
    break;

  case 246: /* primary_expression: FLOAT_VAL  */
#line 708 "chuck.y"
                                            { (yyval.exp) = new_exp_from_float( (yyvsp[0].fval), (yylsp[0]).first_line, (yylsp[0]).first_column ); }
#line 3510 "chuck.tab.c"
    break;

  case 247: /* primary_expression: STRING_LIT  */
#line 709 "chuck.y"
                                            { (yyval.exp) = new_exp_from_str( (yyvsp[0].sval), (yylsp[0]).first_line, (yylsp[0]).first_column ); }
#line 3516 "chuck.tab.c"
    break;

  case 248: /* primary_expression: CHAR_LIT  */
#line 710 "chuck.y"
                                            { (yyval.exp) = new_exp_from_char( (yyvsp[0].sval), (yylsp[0]).first_line, (yylsp[0]).first_column ); }
#line 3522 "chuck.tab.c"
    break;

  case 249: /* primary_expression: array_exp  */
#line 711 "chuck.y"
                                            { (yyval.exp) = new_exp_from_array_lit( (yyvsp[0].array_sub), (yylsp[0]).first_line, (yylsp[0]).first_column ); }
#line 3528 "chuck.tab.c"
    break;

  case 250: /* primary_expression: complex_exp  */
#line 712 "chuck.y"
                                            { (yyval.exp) = new_exp_from_complex( (yyvsp[0].complex_exp), (yylsp[0]).first_line, (yylsp[0]).first_column ); }
#line 3534 "chuck.tab.c"
    break;

  case 251: /* primary_expression: polar_exp  */
#line 713 "chuck.y"
                                            { (yyval.exp) = new_exp_from_polar( (yyvsp[0].polar_exp), (yylsp[0]).first_line, (yylsp[0]).first_column ); }
#line 3540 "chuck.tab.c"
    break;

  case 252: /* primary_expression: vec_exp  */
#line 714 "chuck.y"
                                            { (yyval.exp) = new_exp_from_vec( (yyvsp[0].vec_exp), (yylsp[0]).first_line, (yylsp[0]).first_column ); }
#line 3546 "chuck.tab.c"
    break;

  case 253: /* primary_expression: L_HACK expression R_HACK  */
#line 715 "chuck.y"
                                            { (yyval.exp) = new_exp_from_hack( (yyvsp[-1].exp), (yylsp[-2]).first_line, (yylsp[-2]).first_column ); }
#line 3552 "chuck.tab.c"
    break;

  case 254: /* primary_expression: LPAREN expression RPAREN  */
#line 716 "chuck.y"
                                            { (yyval.exp) = (yyvsp[-1].exp); }
#line 3558 "chuck.tab.c"
    break;

  case 255: /* primary_expression: LPAREN RPAREN  */
#line 717 "chuck.y"
                                                    { (yyval.exp) = new_exp_from_nil( (yylsp[-1]).first_line, (yylsp[-1]).first_column ); }
#line 3564 "chuck.tab.c"
    break;


#line 3568 "chuck.tab.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (YY_("syntax error"));
    }

  yyerror_range[1] = yylloc;
  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, &yylloc);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp, yylsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  ++yylsp;
  YYLLOC_DEFAULT (*yylsp, yyerror_range, 2);

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp, yylsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

